{=======================================================================================================================

  Comming BASE

     .

========================================================================================================================

  :

  30.11.2012 [*] .
  18.03.2011 [*] Private declarations.
  06.10.2010 [*]     .
  26.06.2009 [*]   ToolBar2000.
  20.06.2006 [+] ExecuteCheckItem:    .
  28.10.2004 [*]   .
  15.03.2004 [*]  uses (Icarus).
  09.03.2004 [*]     .
  10.12.2003 [-]  uses (Icarus).
  06.04.2003 [*]    Tahoma.
  26.03.2003 [-]    dmComming.
  22.02.2003 [+]    Help (HTMLHELP)
  14.01.2003 [-]  uses.
  21.12.2002 [*]  Hint.
  27.11.2002 [+]       .
  21.11.2002 [+]  BASEDataDM.imToolBar.
  14.11.2002 [*]   .
  15.09.2002 [-]     Quick Report preview.
  11.09.2002 [+]  .
  10.09.2002 [-]  TAB.
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfmRoot.pas,v 1.20 2012/12/26 04:10:17 tsk Exp $
=======================================================================================================================}
unit BASEfmRoot;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, ExtCtrls,
      DB, TB2Item, TB2Dock, TB2Toolbar, Menus, ActnList, ADODB, PropStorageEh, PropFilerEh,
      // BASE:
      {$IFDEF QUICKREPORT} BASEfrPreview, {$ENDIF}
      BASEdmData,
      // Comming:
      {$IFDEF HTMLHELP} CommingHTMLHelpAPI, {$ENDIF}
      CommingToolBar2000;


type

  TOnClose = procedure of object;

  TBASERootFM = class( TForm )
    pnBase: TPanel;
    liAction: TActionList;
    acBack: TAction;
    dcMain: TTBDock;
    tbMain: TTBToolbar;
    imRootEx: TTBSubmenuItem;
    TBSeparatorItem1: TTBSeparatorItem;
    imBack: TTBItem;
    TBSeparatorItem2: TTBSeparatorItem;
    imHelp: TTBItem;
    TBSeparatorItem3: TTBSeparatorItem;
    acHelp: TAction;
    acBackForm: TAction;
    psMain: TPropStorageEh;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acBackUpdate(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
    procedure acHelpExecute(Sender: TObject);
    procedure acBackFormUpdate(Sender: TObject);
    procedure acBackFormExecute(Sender: TObject);
  private   { Private declarations }
    FAfterClose: TOnClose;
    FBackField: TField;
    FBackForm:  TForm;
    procedure   WMSize( var Message: TWMSize ); message WM_SIZE;
  public    { Public declarations }
    {$IFDEF QUICKREPORT}
    PreviewFrame: TBASEPreviewFR;
    {$ENDIF}
    procedure   CreateParams( var Params: TCreateParams ); override;
    procedure   SetBackForm( Form: TForm; Field: TField ); overload;
    procedure   SetBackForm( AForm: TForm; APBack: TOnClose ); overload;
    procedure   SetBackValue( Value: Variant );
    {$IFDEF QUICKREPORT}
    procedure   MultiReportBegin;
    procedure   MultiReportEnd;
    {$ENDIF}
    procedure   DisableItemSelfRun( Action: TAction );
    procedure   ExecuteCheckItem;
  end;

implementation

{$R *.DFM}
//======================================================================================================================
procedure TBASERootFM.CreateParams( var Params: TCreateParams );
begin
  inherited CreateParams( Params );
  Params.ExStyle    := Params.ExStyle OR WS_EX_APPWINDOW;
  Params.WndParent  := GetDesktopWindow();
end;
//======================================================================================================================
procedure TBASERootFM.FormCreate( Sender: TObject );
begin
  if PixelsPerInch = 96 then tbMain.Font.Size := 9;
  psMain.Section := Copy( Name, 1, Length( Name ) - 2 );
  Icon := Application.Icon;
  {$IFNDEF HTMLHELP}
  acHelp.Visible := False;
  {$ENDIF}
  TB2ExportMenu( imRootEx, Application.MainForm.PopupMenu );
end;
//======================================================================================================================
procedure TBASERootFM.FormClose( Sender: TObject; var Action: TCloseAction );
  var i: Integer;
begin
  Action := caFree;
  for i := 0 to Screen.FormCount - 1 do
    if ( Screen.Forms[i] is TBASERootFM ) and ( Screen.Forms[i] <> Self ) then Exit;
  Application.Terminate;
end;
//======================================================================================================================
procedure TBASERootFM.acBackUpdate(Sender: TObject);
begin
  TAction( Sender ).Enabled := (FBackField <> nil);
end;
//======================================================================================================================
procedure TBASERootFM.acBackExecute(Sender: TObject);
begin
  try try
    FBackForm.Show;
  except end;
  finally
    FBackForm := nil;
    FBackField := nil;
  end;
end;
//======================================================================================================================
procedure TBASERootFM.acBackFormUpdate( Sender: TObject );
begin
  TAction( Sender ).Enabled := (FBackForm <> nil);
end;
//======================================================================================================================
procedure TBASERootFM.acBackFormExecute(Sender: TObject);
begin
  try try
    if Assigned( FAfterClose ) then FAfterClose;
    FBackForm.Show;
  except end;
  finally
    FBackForm   := nil;
    FAfterClose := nil;
  end;
end;
//======================================================================================================================
procedure TBASERootFM.acHelpExecute(Sender: TObject);
begin
{$IFDEF HTMLHELP}
  HTMLHelpShow( Application.Title, Self.psMain.Section, True );
{$ENDIF}
end;
//======================================================================================================================
procedure TBASERootFM.SetBackForm( Form: TForm; Field: TField );
begin
  FBackForm   := Form;
  FBackField  := Field;
  if ( Form <> nil ) and ( Field <> nil )
    then acBack.Hint := Format( '   "%s"'#13#10'   "%s"',
                                [ FBackForm.Caption, FBackField.DisplayLabel ]);
end;
//======================================================================================================================
procedure TBASERootFM.SetBackForm( AForm: TForm; APBack: TOnClose );
begin
  FBackForm       := AForm;
  FAfterClose     := APBack;
  acBackForm.Hint := Format( '   "%s"', [ FBackForm.Caption ]);
  imBack.Action   := acBackForm;
end;
//======================================================================================================================
procedure TBASERootFM.SetBackValue( Value: Variant );
begin
  try
    if FBackField <> nil then begin
      if ( FBackField.LookupDataSet is TADODataSet)
        then TADODataSet( FBackField.LookupDataSet ).Requery;
      if not( FBackField.DataSet.State in [ dsInsert, dsEdit ] ) then FBackField.DataSet.Edit;
      FBackField.Value := Value;
    end;
  except
    FBackForm := nil;
    FBackField := nil;
  end;
end;
//======================================================================================================================
procedure TBASERootFM.WMSize( var Message: TWMSize );
begin
  inherited;
  //     .
  if ( Left < -10 ) or ( Left > GetSystemMetrics( SM_CXSCREEN )) then Left := 10;
  if ( Top < -10 )  or ( Top  > GetSystemMetrics( SM_CYSCREEN )) then Top  := 10;
end;
//======================================================================================================================
{$IFDEF QUICKREPORT}
procedure TBASERootFM.MultiReportBegin;
begin
  if PreviewFrame = nil then begin
    PreviewFrame := TBASEPreviewFR.Create( Self );
    PreviewFrame.Parent := Self;
  end;
  PreviewFrame.MultiBegin;
end;
//======================================================================================================================
procedure TBASERootFM.MultiReportEnd;
begin
  PreviewFrame.MultiEnd;
end;
{$ENDIF}
//======================================================================================================================
procedure TBASERootFM.DisableItemSelfRun( Action: TAction );

  procedure Recurse ( Item: TTBCustomItem; Action: TAction );
    var i: Integer;
  begin
    for i := 0 to Item.Count - 1 do begin
      if Item.Items[i].Action = Action then Item.Items[i].Enabled := False;
      if ( Item.Items[i] is TTBSubmenuItem ) then Recurse( Item.Items[i], Action);
    end;
  end;

begin
  Recurse( imRootEx, Action );
end;
//======================================================================================================================
procedure TBASERootFM.ExecuteCheckItem;
  var i: Integer;
begin
  for i := 0 to Self.ComponentCount - 1 do begin
    if ( Self.Components[i] is TAction ) and TAction( Self.Components[i] ).Checked
      then TAction( Self.Components[i] ).Execute;
  end;
end;
//======================================================================================================================
end.
