{===================================================================================================

  Comming BASE

      (QuickReport).

====================================================================================================

  :

  16.08.2007 [*]     .
  20.05.2004 [*]     .
  09.05.2004 [+] pmTools: TPopupMenu    .
  08.04.2003 [+]  TPropStorageEh.
  19.09.2002 [+]     .
  26.12.2001 [+]    .
  17.12.2001 [+]     .
  15.06.2001 [+]    .
  14.06.2001 [+]  .
  06.04.1999 [!]   BASE.

====================================================================================================
  Copyright 19992007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: BASEqrRoot.pas,v 1.8 2009/07/13 05:21:28 tsk Exp $
===================================================================================================}
unit BASEqrRoot;

interface

uses  Windows, SysUtils, Messages, Classes, Graphics, Controls, StdCtrls, ExtCtrls, Forms, Quickrpt,
      QRCtrls, PropStorageEh, PropFilerEh, Menus,
      // BASE:
      BASEfmRoot, BASEfrPreview,
      // Comming:
      CommingToolBar2000;


type
  TBASERootQR = class( TQuickRep )
    psRoot: TPropStorageEh;
    pmTools: TPopupMenu;
    procedure QuickRepPreview( Sender: TObject );
  private   { Private declarations }
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    destructor  Destroy; override;
  end;

implementation
{$IFDEF QUICKREPORFORM}
uses BASEfmReport;
{$ENDIF}
{$R *.DFM}
//==================================================================================================
{ TBASERootQR }
//==================================================================================================
constructor TBASERootQR.Create( AOwner: TComponent );
begin
  inherited Create(AOwner);
  psRoot.Section := Copy( Name, 1, Length( Name ) - 2 );
  psRoot.LoadProperties;
end;
//==================================================================================================
destructor TBASERootQR.Destroy;
begin
  psRoot.SaveProperties;
  inherited;
end;
//==================================================================================================
procedure TBASERootQR.QuickRepPreview( Sender: TObject );
  var Fm: TBASERootFM;
begin
  if ( Owner is TBASERootFM ) then begin
    {$IFDEF QUICKREPORFORM}
    if Owner is TBASEReportFM then begin
      TBASEReportFM( Owner ).frReport.Add( QRPrinter )
    end else begin
    {$ENDIF}
      Fm := TBASERootFM( Owner );
      if Fm.PreviewFrame = nil then begin
        Fm.PreviewFrame := TBASEPreviewFR.Create( Fm );
        Fm.PreviewFrame.Parent := Fm;
      end;
      if ( pmTools.Items.Count > 0 ) and (Fm.PreviewFrame.imTools.Count = 0 ) then begin
        TB2ExportMenu( Fm.PreviewFrame.imTools, pmTools );
        Fm.PreviewFrame.imTools.Visible := True;
      end;
      Fm.PreviewFrame.ShowModal;
      Fm.PreviewFrame.Add( QRPrinter );
    {$IFDEF QUICKREPORFORM}
    end;
    {$ENDIF}
  end;
  Application.ProcessMessages;
end;
//==================================================================================================
end.
