{=======================================================================================================================

  Comming BASE

     . DBLookupCombo,        .

========================================================================================================================

  :

  03.08.2013 [*] .
  28.05.2008 [+] KeyValue   .
  05.04.2005 [+]   NoClicl.
  26.04.2004 [+]  (TDataSource)     (Lookup).
  01.04.2004 [+]     (Lookup).
  26.11.2002 [*]  ImageList.
  18.08.2002 [*]  TcoToolbarButton97  TcoButton.
  16.01.2002 [*] .
  12.12.2001 [+]   ReadOnly.
  06.12.2001 [+]  Hint -.
             [+] Enabled:  .
  01.12.2001 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEsfDBLookupCombo.pas,v 1.11 2013/08/14 05:51:44 tsk Exp $
=======================================================================================================================}
unit BASEsfDBLookupCombo;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, DB, Variants,
      // Comming:
      CommingLookupFlat, CommingButton;

type
  TBASEDBLookupComboSF = class(TFrame)
    btLabel: TcoButton;
    cbField: TcoDBLookupCombo;
  private   { Private declarations }
    FEnabled:   Boolean;
    FReadOnly:  Boolean;
    FNoClick:   Boolean;
    procedure   SetEnabledX( const Value: Boolean );
    procedure   SetReadOnly(const Value: Boolean);
    function    GetKeyValue: Integer;
  public    { Public declarations }
    procedure   RequeryLookup( Lookup: TDataSource = nil );
    property    Enabled: Boolean read FEnabled write SetEnabledX;
    property    ReadOnly: Boolean read FReadOnly write SetReadOnly;
    property    KeyValue: Integer read GetKeyValue;
  end;

implementation

{$R *.dfm}
//======================================================================================================================
{ TBASEDBLookupComboSF }
//======================================================================================================================
procedure TBASEDBLookupComboSF.SetEnabledX( const Value: Boolean );
begin
  FEnabled          := Value;
  btLabel.Enabled   := Value;
  cbField.ReadOnly  := not Value;
  cbField.TabStop   := Value;
end;
//======================================================================================================================
procedure TBASEDBLookupComboSF.SetReadOnly( const Value: Boolean );
begin
  FReadOnly         := Value;
  cbField.ReadOnly  := Value;
  if btLabel.NoClick <> Value then
    if btLabel.NoClick
      then FNoClick := True
      else if not FNoClick then btLabel.NoClick := Value;
  cbField.TabStop   := not Value;
end;
//======================================================================================================================
procedure TBASEDBLookupComboSF.RequeryLookup( Lookup: TDataSource = nil );
begin
  if cbField.LookupSource = nil then cbField.LookupSource := Lookup;
  if cbField.LookupSource <> nil then
    with cbField.LookupSource.DataSet do begin
      Close;
      Open;
    end;
end;
//======================================================================================================================
function TBASEDBLookupComboSF.GetKeyValue: Integer;
begin
  if cbField.KeyValue = null then Result := -1 else Result := cbField.KeyValue;
end;
//======================================================================================================================
end.
