{=======================================================================================================================

  Comming BASE

        Internet.

========================================================================================================================

  :

  14.02.2015 [*]     .
             [*]     .
  25.10.2012 [+]  .
  23.10.2012 [*]   .
  22.10.2012 [*]   .
  16.01.2012 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                   http://www.tsklab.ru
  CVS: $Id: BASEfrSearchWeb.pas,v 1.5 2015/02/14 01:15:22 tsk Exp $
=======================================================================================================================}
unit BASEfrSearchWeb;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, OleCtrls,
      SHDocVw, MSHTML,
      // BASE:
      BASEfrRoot,
      // Comming:
      CommingButton, CommingFlat, CommingString, CommingInternet, CommingLog;

type

  TChoiceKey = procedure ( Value: String ) of object;

  TBASESearchWebFR = class(TBASERootFR)
    laTitle: TStaticText;
    btValue: TcoButton;
    btView: TcoButton;
    webSearch: TWebBrowser;
    pnView: TPanel;
    mmParam: TcoMemo;
    mmValue: TcoMemo;
    spValue: TSplitter;
    edRequest: TEdit;
    pnRequest: TPanel;
    procedure btViewClick(Sender: TObject);
    procedure btValueClick(Sender: TObject);
    procedure FrameResize(Sender: TObject);
  private   { Private declarations }
    OnAfterChoice: TChoiceKey;
  public    { Public declarations }
    constructor CreateComming( AOwner: TComponent; PAChoice: TChoiceKey );
    procedure   OpenSearch( Search, Request: String);
    function    GetPart( CB, CE: String ): String;
    function    GetValue( CB, CE: String ): String;
    function    GetList( HTML, CB, CE: String ): String;
  end;

implementation

uses BASEdmData;

{$R *.dfm}
//======================================================================================================================
{ TBASESearchWebFR }
//======================================================================================================================
constructor TBASESearchWebFR.CreateComming(AOwner: TComponent; PAChoice: TChoiceKey );
begin
  inherited Create( AOwner );
  OnAfterChoice := PAChoice;
  webSearch.Silent := True;
//  if webSearch.Silent then ShowMessage('1');
 end;
//======================================================================================================================
procedure TBASESearchWebFR.FrameResize(Sender: TObject);
begin
  inherited;
  edRequest.Width := ClientWidth - 2;
end;
//======================================================================================================================
procedure TBASESearchWebFR.OpenSearch( Search, Request: String);
begin
  laTitle.Caption := ' ' + ExtractHost( Search );
  Request := Trim( Request );
  edRequest.Text := Request;
  DeleteChars( Request, '&' );
  StringReplace( Request, ' ', '+', [ rfReplaceAll ]);
  webSearch.Navigate( Search + Request );
  pnView.Visible := False;
  btView.ImageIndex := 43;
  mmValue.Clear;
end;
//======================================================================================================================
procedure TBASESearchWebFR.btViewClick( Sender: TObject );
begin
  pnView.Visible := not pnView.Visible;
  if pnView.Visible then btView.ImageIndex := 35 else btView.ImageIndex := 43;
end;
//======================================================================================================================
function TBASESearchWebFR.GetPart(CB, CE: String): String;
  var b: Integer;
      HTML, r: String;
begin
  HTML := webSearch.OleObject.document.all.tags('html').item(0).innerHTML;
//  WriteLog( HTML );
  r := AnsiUpperCase( HTML );
  CB := AnsiUpperCase( CB );
  CE := AnsiUpperCase( CE );
//  WriteLog( r + '|' + CB );
  b := Pos( CB, r ) + Length( CB );
  HTML := Copy( HTML, b, MaxInt );
  r := Copy( r, b, MaxInt );
  b := Pos( CE, r ) - 1;
  Result := Copy( HTML, 1, b );
end;
//======================================================================================================================
function TBASESearchWebFR.GetValue(CB, CE: String): String;
begin
  Result := Trim( HTMLDeleteTag( HTMLReplaceSymbol( GetPart( CB, CE ))));
end;
//======================================================================================================================
function TBASESearchWebFR.GetList( HTML, CB, CE: String ): String;
  var b: Integer;
      r: String;
begin
  Result := '';
  r := AnsiUpperCase( HTML );
  CB := AnsiUpperCase( CB );
  CE := AnsiUpperCase( CE );
  while ( Pos( CB, r ) > 0 ) do begin
    b := Pos( CB, r ) + Length( CB );
    HTML := Copy( HTML, b, MaxInt );
    r := Copy( r, b, MaxInt );
    b := Pos( CE, r ) - 1;
    if Result <> '' then Result := Result + ', ';
    Result := Result + HTMLDeleteTag( Copy( HTML, 1, b ));
    HTML := Copy( HTML, b + 1, MaxInt );
    r := AnsiUpperCase( HTML );
  end;
  b := Pos( ', ...', Result);
  if ( b > 0 ) then Result := Copy( Result, 1, b - 1);
end;
//======================================================================================================================
procedure TBASESearchWebFR.btValueClick(Sender: TObject);
begin
  if Assigned( OnAfterChoice ) then OnAfterChoice( mmValue.Text );
  CloseModal;
end;
//======================================================================================================================
end.
