{=======================================================================================================================

   "Videoteq".

     .

========================================================================================================================

  :

  31.03.2015 [*] 2015 .
  11.10.2012 [*]  .
  07.10.2012 [+] :    .
  05.10.2012 [*] .
  17.02.2011 [+] CodecDeterminant:   .
  14.01.2011 [+] DistinctFile:  .
  18.05.2010 [+]  .
  30.08.2008 [+]  .
             [+] FormatTitle:  .
  16.12.2006 [+] GoToFilm:   ,    .
  10.10.2006 [+]   , .
  16.04.2006 [-]  .
  11.04.2006 [+] acCollection: .
             [+] acFilmKind:  .
  07.04.2006 [-]   .
  23.05.2005 [*]   .
  05.05.2005 [+] acVersion: copyright.
  17.03.2005 [+] acCodec:  .
  16.03.2005 [+] acSearch:  .
  14.03.2005 [+] acStorage: .
  28.02.2005 [+]     .
  31.01.2005 [+] acPublication:     .
  29.01.2005 [+] acFilm:  .
             [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dmCommingData.pas,v 1.34 2015/03/31 03:41:01 tsk Exp $
=======================================================================================================================}
unit dmCommingData;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ImgList, Menus, Db,
      ADODB, ActnList, PropStorageEh, PropFilerEh, Math,
      //Comming:
      CommingADO, CommingVersionInfo, CommingOther, CommingString;

type

  TdmComming = class( TDataModule )
    cnVideo: TADOConnection;
    alExec: TActionList;
    acExit: TAction;
    acVersion: TAction;
    pmExecute: TPopupMenu;
    imPerforner: TMenuItem;
    acVersion1: TMenuItem;
    _N4: TMenuItem;
    _N5: TMenuItem;
    N1: TMenuItem;
    acFilm: TAction;
    imPubl: TImageList;
    acPublication: TAction;
    N2: TMenuItem;
    N3: TMenuItem;
    taInstant: TADODataSet;
    taInstantText: TStringField;
    acStorage: TAction;
    N4: TMenuItem;
    N5: TMenuItem;
    acSearch: TAction;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    imCatalog: TMenuItem;
    acCodec: TAction;
    N10: TMenuItem;
    acFilmKind: TAction;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    acAttributeGroup: TAction;
    acAttributeValue: TAction;
    N18: TMenuItem;
    N19: TMenuItem;
    acScan: TAction;
    acSubstitute: TAction;
    taSubstitute: TADODataSet;
    taSubstituteID: TIntegerField;
    taSubstituteOld: TStringField;
    taSubstituteNew: TStringField;
    N16: TMenuItem;
    N17: TMenuItem;
    acUnitKind: TAction;
    N20: TMenuItem;
    N21: TMenuItem;
    acWatch: TAction;
    N22: TMenuItem;
    acCodecDeterminant: TAction;
    procedure acExitExecute(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure acVersionExecute(Sender: TObject);
    procedure acFilmExecute(Sender: TObject);
    procedure acPublicationExecute(Sender: TObject);
    procedure acStorageExecute(Sender: TObject);
    procedure acSearchExecute(Sender: TObject);
    procedure acCodecExecute(Sender: TObject);
    procedure acFilmKindExecute(Sender: TObject);
    procedure acAttributeGroupExecute(Sender: TObject);
    procedure acAttributeValueExecute(Sender: TObject);
    procedure acScanExecute(Sender: TObject);
    procedure acSubstituteExecute(Sender: TObject);
    procedure acUnitKindExecute(Sender: TObject);
    procedure acWatchExecute(Sender: TObject);
    procedure acCodecDeterminantExecute(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    procedure   RunModule;
    procedure   GoToFilm( Film: Integer );
    function    FormatTitle( Title: String ): String;
    function    DistinctFile( FileName: String ): String;
  end;

  var dmComming: TdmComming;

implementation

uses  fmFilm, fmStorage, fmSearch, fmWatch, fmCodec, fmCodecDeterminant, fmPublication, fmFilmKind, fmScan,
      fmAttributeGroup, fmAttributeValue, fmSubstituteList, fmUnitKind;

{$R *.DFM}
//======================================================================================================================
{ TdmComming }
//======================================================================================================================
procedure TdmComming.DataModuleCreate(Sender: TObject);
begin
  acVersion.Caption               := GetVersion;
  Application.MainForm.PopupMenu  := pmExecute;
  SetProduct;
  taInstant.Open;
  acVersion.Hint := ' .'#13' 20042015, TSK Developer Laboratory, Moscow.'
                     + #13#13' :';
  while not taInstant.Eof do begin
    acVersion.Hint := acVersion.Hint + #13#10 + taInstantText.Value;
    taInstant.Next;
  end;
  taInstant.Close;
end;
//======================================================================================================================
procedure TdmComming.RunModule;
  var Comm: String;
begin
  Comm := GetCommandLine;
  if cnVideo.Connected then begin
    FilmRun;
    if Pos( 'publ', Comm ) > 0    then PublicationRun;
    if Pos( 'place', Comm ) > 0   then StorageRun;
    if Pos( 'search', Comm ) > 0  then SearchRun;
    if Pos( 'scan', Comm ) > 0    then ScanRun;
  end else Application.Terminate;
end;
//======================================================================================================================
{   }
//======================================================================================================================
procedure TdmComming.GoToFilm( Film: Integer );
begin
  FilmDeman( Film );
end;
//======================================================================================================================
function TdmComming.FormatTitle( Title: String ): String;
begin
  Result := Trim( UpperFirstLetterWord( Title ));
  if not taSubstitute.Active then taSubstitute.Open;
  taSubstitute.First;
  while not taSubstitute.Eof do begin
    Result := StringReplace( Result,  taSubstituteOld.Value, taSubstituteNew.Value,
                                                                    [ rfReplaceAll, rfIgnoreCase ]);
    taSubstitute.Next;
  end;
end;
//======================================================================================================================
function TdmComming.DistinctFile( FileName: String ): String;
  var buff: Longword;
      d: Int64;
begin
  with TFileStream.Create( FileName, fmOpenRead or fmShareDenyWrite) do
    try
      Result := IntToHex( Size, 10 );
      // RIFF
      Position := 4;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
      // 1/4 
      d := round( Size / 4 );
      Position := d;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
      // 3/4 
      Position := Size - d;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
    finally
      Free;
    end;
end;
//======================================================================================================================
{   }
//======================================================================================================================
procedure TdmComming.acFilmExecute(Sender: TObject);
begin
  FilmRun;
end;
//======================================================================================================================
procedure TdmComming.acStorageExecute(Sender: TObject);
begin
  StorageRun;
end;
//======================================================================================================================
procedure TdmComming.acSearchExecute(Sender: TObject);
begin
  SearchRun;
end;
//======================================================================================================================
procedure TdmComming.acWatchExecute(Sender: TObject);
begin
  WatchRun;
end;
//======================================================================================================================
procedure TdmComming.acScanExecute(Sender: TObject);
begin
  ScanRun;
end;
//======================================================================================================================
procedure TdmComming.acPublicationExecute(Sender: TObject);
begin
  PublicationRun;
end;
//======================================================================================================================
procedure TdmComming.acFilmKindExecute(Sender: TObject);
begin
  FilmKindRun;
end;
//======================================================================================================================
procedure TdmComming.acCodecExecute(Sender: TObject);
begin
  CodecRun;
end;
//======================================================================================================================
procedure TdmComming.acCodecDeterminantExecute(Sender: TObject);
begin
  CodecDeterminant;
end;
//======================================================================================================================
procedure TdmComming.acAttributeGroupExecute(Sender: TObject);
begin
  FilmAttributeGroup;
end;
//======================================================================================================================
procedure TdmComming.acAttributeValueExecute(Sender: TObject);
begin
  FilmAttributeValue;
end;
//======================================================================================================================
procedure TdmComming.acSubstituteExecute(Sender: TObject);
begin
  SubstituteRun;
end;
//======================================================================================================================
procedure TdmComming.acUnitKindExecute(Sender: TObject);
begin
  UnitKindRun;
end;
//======================================================================================================================
procedure TdmComming.acVersionExecute(Sender: TObject);
begin
  Beep;
end;
//======================================================================================================================
procedure TdmComming.acExitExecute(Sender: TObject);
begin
  Application.Terminate;
end;
//======================================================================================================================
end.
