{=======================================================================================================================

   "Videoteq".

     .

========================================================================================================================

  :

  07.10.2012 [*] FindAttributeValue:     .
  19.02.2011 [-] FindFCC:   FindCodec.
             [*] FindCodec:    "".
  20.05.2008 [+] FindFCC:    FCC.
  09.08.2007 [+] FindHeading:   .
  03.08.2007 [*] FindCodec: .
             [*] FindAttributeGroup: .
  27.07.2007 [*] FindCodec:  null.
             [*] FindAttributeGroup:  .
  15.04.2007 [*] FindAttributeValue:    .
  27.03.2007 [*] FindAttributeValue:     .
  12.01.2007 [+] FindCodec:  .
  11.01.2007 [+] FindAttributeGroup:   .
  28.12.2006 [+] FindAttributeValue:   .
             [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dmFindValue.pas,v 1.13 2012/10/22 07:08:29 tsk Exp $
=======================================================================================================================}
unit dmFindValue;

interface

uses  SysUtils, Classes, Variants, DB, ADODB, StrUtils,
      // Comming:
      CommingADO, CommingString;

type
  TCodecKind = ( ckVideo, ckAudio );

  TdmFind = class(TDataModule)
    taAttributeValue: TADODataSet;
    taAttributeValueID: TAutoIncField;
    taAttributeValueGroup: TSmallintField;
    taAttributeValueValue: TStringField;
    taAttributeGroup: TADODataSet;
    taAttributeGroupID: TSmallintField;
    taAttributeGroupName: TStringField;
    taCodec: TADODataSet;
    taCodecID: TSmallintField;
    taCodecName: TStringField;
    taFindFilm: TADODataSet;
    taFindFilmHeading: TIntegerField;
    taFindFilmGroup: TStringField;
    taCodecDeterminant: TADODataSet;
    taCodecDeterminantID: TAutoIncField;
    taCodecDeterminantCodec: TIntegerField;
    taCodecDeterminantDeterminant: TStringField;
    taCodecKind: TStringField;
    taAttSearch: TADODataSet;
    taAttSearchID: TIntegerField;
    taAttSearchValue: TStringField;
  private   { Private declarations }
  public    { Public declarations }
    function  FindCodec( Kind: TCodecKind; Determ: String ): Integer;
    function  FindAttributeGroup( Name: String; Add: String = '' ): Integer;
    function  FindAttributeValue( Group: Integer; Value: String; Add: String = '' ): Integer;
    function  FindFilm( Film: Integer): Variant;
    function  GetAttributeGroup( ID: Integer ): Integer;
  end;

var dmFind: TdmFind;

resourcestring
  sqlFindKind   = 'SELECT Kind FROM FilmKind WHERE (Kind = ''%s'')';
  sqlFindAttrGr = 'SELECT ID FROM FilmAttributeGroup' +
                    ' WHERE (Name = ''%s'') OR (NameMany = ''%s'') OR (NameVariation like ''%%%s%%'')';
//  sqlFindValue  = 'SELECT ID FROM FilmAttributeValue WHERE ([Group] = %d) ' +
//                    'AND (Value like ''%%%s%%'') AND (Value like ''%%%s%%'')';
  sqlFindCodec  = 'SELECT Codec FROM CodecDeterminant WHERE (Determinant = ''%s'')';
  sqlFindFilm   = 'SELECT ISNULL(Heading, 0), [Group] FROM Film WHERE (ID = %d)';
  sqlGetGroupe  = 'SELECT [Group] FROM FilmAttributeValue WHERE ( ID = %d)';

implementation

uses dmCommingData;

{$R *.dfm}
//======================================================================================================================
{ TdmFind }
//======================================================================================================================
function TdmFind.FindAttributeGroup( Name, Add: String ): Integer;
  var VL: Variant;
begin
  VL := SQLCalculate( dmComming.cnVideo, sqlFindAttrGr, [ Name, Name, Name ]);
  if VL = null then begin
    taAttributeGroup.Open;
    taAttributeGroup.Insert;
    taAttributeGroupName.Value := Name + Add;
    taAttributeGroup.Post;
    VL := taAttributeGroupID.Value;
    taAttributeGroup.Close;
  end;
  Result := VL;
end;
//======================================================================================================================
function TdmFind.FindAttributeValue( Group: Integer; Value, Add: String ): Integer;
begin
  Result := -1;
  RequeryParameters( taAttSearch, [ Group, Value ]);
  if taAttSearch.RecordCount > 0 then Result := taAttSearchID.Value;
  taAttSearch.Close;
  if Result = -1 then begin
    taAttributeValue.Open;
    taAttributeValue.Insert;
    taAttributeValueGroup.Value := Group;
    taAttributeValueValue.Value := Value + Add;
    taAttributeValue.Post;
    Result := taAttributeValueID.Value;
    taAttributeValue.Close;
  end;
end;
//======================================================================================================================
function TdmFind.FindCodec( Kind: TCodecKind; Determ: String ): Integer;
  var VL: Variant;
begin
  Result := -1;
  if Determ = '' then Exit;
  case Kind of
    ckVideo: Determ := 'V|' + Determ;
    ckAudio: Determ := 'A|' + Determ;
  end;
  VL := SQLCalculate( dmComming.cnVideo, sqlFindCodec, [ Determ ]);
  if VL = null then begin
    taCodec.Open;
    taCodec.Insert;
    taCodecKind.Value := Determ[1];
    taCodecName.Value := Determ;
    taCodec.Post;
    VL := taCodecID.Value;
    taCodec.Close;
    taCodecDeterminant.Open;
    taCodecDeterminant.Insert;
    taCodecDeterminantCodec.Value := VL;
    taCodecDeterminantDeterminant.Value := Determ;
    taCodecDeterminant.Post;
    taCodecDeterminant.Close;
  end;
  Result := VL;
end;
//======================================================================================================================
function TdmFind.FindFilm(Film: Integer): Variant;
begin
  RequeryParameters( taFindFilm, [ Film ]);
  if taFindFilm.RecordCount = 0
    then Result := VarArrayOf( [ -1, '*' ])
    else Result := VarArrayOf( [ taFindFilmHeading.Value, taFindFilmGroup.Value ]);
  taFindFilm.Close;
end;
//======================================================================================================================
function TdmFind.GetAttributeGroup( ID: Integer ): Integer;
  var VL: Variant;
begin
  VL := SQLCalculate( dmComming.cnVideo, sqlGetGroupe, [ ID ]);
  if VL = null then VL := -1;
  Result := VL;
end;
//======================================================================================================================
end.
