/*=================================================================================================

   "Videoteq".

       .

===================================================================================================

  :

  09.10.2011 [+]      'SchemaDate'.
  26.05.2011 [+]     .
  01.03.2005 [*] .
  29.01.2005 TSK  [+]  .
  17.12.2004 TSK  [!]  .

===================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scCheckDrop.sql,v 1.2 2012/10/22 07:08:29 tsk Exp $
=================================================================================================*/
USE Videoteq
--
IF EXISTS (SELECT name FROM sysobjects WHERE name = 'CheckDropProcedure' AND type = 'P')
  DROP PROCEDURE CheckDropProcedure
  DECLARE @VL VARCHAR(20)
  SET @VL = CONVERT( VARCHAR, GETDATE(), 104)
  EXECUTE sp_updateextendedproperty 'SchemaDate', @VL
--
GO
--=================================================================================================
CREATE PROCEDURE CheckDropProcedure @Name VARCHAR(100)
AS
  DECLARE @SQL VARCHAR(100), @VL VARCHAR(20)
  IF EXISTS (SELECT name FROM sysobjects WHERE name = @Name AND type = 'P') BEGIN
    SET @SQL = 'DROP PROCEDURE ' + @Name
    EXECUTE( @SQL )
    SET @VL = CONVERT( VARCHAR, GETDATE(), 104)
    EXECUTE sp_updateextendedproperty 'SchemaDate', @VL
  END ELSE PRINT ' ' + @Name
--
GO
--=================================================================================================
EXECUTE CheckDropProcedure 'CheckDropTrigger'
--
GO
--=================================================================================================
CREATE PROCEDURE CheckDropTrigger @Name VARCHAR(100)
AS
  DECLARE @SQL VARCHAR(100), @VL VARCHAR(20)
  IF EXISTS (SELECT name FROM sysobjects WHERE name = @Name AND type = 'TR') BEGIN
    SET @SQL = 'DROP TRIGGER ' + @Name
    EXECUTE( @SQL )
    SET @VL = CONVERT( VARCHAR, GETDATE(), 104)
    EXECUTE sp_updateextendedproperty 'SchemaDate', @VL
  END ELSE PRINT ' ' + @Name
--
GO
--=================================================================================================
EXECUTE CheckDropProcedure 'CheckDropView'
--
GO
--=================================================================================================
CREATE PROCEDURE CheckDropView @Name VARCHAR(100)
AS
  DECLARE @SQL VARCHAR(100), @VL VARCHAR(20)
  IF EXISTS (SELECT TABLE_NAME FROM INFORMATION_SCHEMA.VIEWS WHERE TABLE_NAME = @Name ) BEGIN
    SET @SQL = 'DROP VIEW ' + @Name
    EXECUTE( @SQL )
    SET @VL = CONVERT( VARCHAR, GETDATE(), 104)
    EXECUTE sp_updateextendedproperty 'SchemaDate', @VL
  END ELSE PRINT ' ' + @Name
--
GO
--=================================================================================================
EXECUTE CheckDropProcedure 'CheckDropFunction'
--
GO
--=================================================================================================
CREATE PROCEDURE CheckDropFunction @Name VARCHAR(100)
AS
  DECLARE @SQL VARCHAR(100), @VL VARCHAR(20)
  IF EXISTS (SELECT name FROM sysobjects WHERE name = @Name ) BEGIN
    SET @SQL = 'DROP FUNCTION ' + @Name
    EXECUTE( @SQL )
    SET @VL = CONVERT( VARCHAR, GETDATE(), 104)
    EXECUTE sp_updateextendedproperty 'SchemaDate', @VL
  END ELSE PRINT ' ' + @Name
--
GO
--=================================================================================================
-- :
--EXECUTE CheckDropProcedure 'Test'
SELECT value FROM sys.extended_properties WHERE name = 'SchemaDate'
