{=======================================================================================================================

   "Videoteq".

      , .

========================================================================================================================

  :

  24.10.2012 [+]   .
  14.06.2008 [+]     .
  27.07.2007 [+]     .
             [*]      .
  28.05.2007 [*]     ,  .
  08.03.2007 [*]     .
  28.12.2006 [+]    .
  17.12.2006 [+]  .
  10.10.2006 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmAttributeValue.pas,v 1.6 2012/10/26 10:41:55 tsk Exp $
=======================================================================================================================}
unit fmAttributeValue;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, PrnDbgeh,
      DB, ADODB, ActnList, TB2Item, TB2Dock, TB2Toolbar, Grids, DBGridEh, ExtCtrls, DBActns,
      StdCtrls, PropStorageEh, PropFilerEh,
      // BASE:
      BASEfmRoot, BASEfmTableEdit, BASEsfDBEdit, BASEsfDBLookupCombo, BASEsfButtonEdit, BASEsfEdit,
      // Comming:
      CommingDBGridEh, CommingADO, TB2ExtItems;

type
  TFilmAttributeValueFM = class( TBASETableEditFM )
    frName: TBASEDBEditSF;
    frGroup: TBASEDBLookupComboSF;
    frFind: TBASEEditSF;
    TBItem14: TTBItem;
    TBSeparatorItem9: TTBSeparatorItem;
    frTranslat: TBASEDBEditSF;
    taTableID: TAutoIncField;
    taTableGroup: TSmallintField;
    taTableValue: TStringField;
    taTableValueTranslat: TStringField;
    taTableValueFull: TStringField;
    taTablePerson: TIntegerField;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure frGroupcbFieldChange(Sender: TObject);
    procedure taTableAfterInsert(DataSet: TDataSet);
    procedure acBackExecute(Sender: TObject);
    procedure frFindedFieldChange(Sender: TObject);
    procedure grTableDblClick(Sender: TObject);
    procedure TBItem14Click(Sender: TObject);
    procedure taTableAfterPost(DataSet: TDataSet);
  private   { Private declarations }
    procedure RequeryTable;
  public    { Public declarations }
  end;

  procedure FilmAttributeValue( Back: TForm = nil; Data: TField = nil; Group: Integer = 1; Proc: TOnClose = nil);

var FilmAttributeValueFM: TFilmAttributeValueFM;

implementation

uses dmLookupComboData, dmCommingData, fmSearch;
{$R *.dfm}
//======================================================================================================================
procedure FilmAttributeValue( Back: TForm; Data: TField; Group: Integer; Proc: TOnClose );
begin
  if FilmAttributeValueFM = nil then begin
    Application.CreateForm( TFilmAttributeValueFM, FilmAttributeValueFM );
  end;
  with FilmAttributeValueFM do begin
    frGroup.RequeryLookup( dmCombo.dsAttribute );
    frGroup.cbField.KeyValue := Group;
    frGroupcbFieldChange( FilmAttributeValueFM );
    if Data <> nil then frFind.edField.Clear;
    RequeryTable;
    Show;
    SetBackForm( Back, Data );
    if Data <> nil then taTable.Locate( 'ID', Data.Value, [] );
  end;
end;
//======================================================================================================================
{ TFilmAttributeValueFM }
//======================================================================================================================
procedure TFilmAttributeValueFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acAttributeValue );
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.FormDestroy(Sender: TObject);
begin
  inherited;
  FilmAttributeValueFM := nil;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.frGroupcbFieldChange(Sender: TObject);
begin
  inherited;
  RequeryTable;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.taTableAfterInsert(DataSet: TDataSet);
begin
  inherited;
  taTable.FieldValues['Group'] := frGroup.cbField.KeyValue;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.acBackExecute(Sender: TObject);
begin
  SetBackValue( taTable.FieldValues['ID'] );
  inherited;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.RequeryTable;
begin
  with taTable do begin
    Close;
    CommandText := 'select * from FilmAttributeValue where ([Group]='
                     + frGroup.cbField.KeyValue + ')';
    if Length( frFind.edField.Text ) > 2
      then CommandText := CommandText + ' and ([Value] like ''%' + frFind.edField.Text + '%'')';
    Open;
  end;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.frFindedFieldChange(Sender: TObject);
begin
  RequeryTable;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.grTableDblClick(Sender: TObject);
begin
  frFind.edField.Text := taTable.FieldValues['Value'];
  RequeryTable;
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.TBItem14Click(Sender: TObject);
begin
  SearchAttributeRun( taTable.FieldValues['ID']);
end;
//======================================================================================================================
procedure TFilmAttributeValueFM.taTableAfterPost(DataSet: TDataSet);
  var Key: Integer;
begin
  Key := taTableID.Value;
  RequeryTable;
  taTable.Locate( 'ID', Key, []);
end;
//======================================================================================================================
end.
