{=======================================================================================================================

   "Videoteq".

     , , .

========================================================================================================================

  :

  25.10.2012 [*]    .
             [*]     .
  23.10.2012 [+] :  .
  07.10.2012 [*]       .
  08.03.2007 [*]     " /Name/".
  16.01.2007 [+]  , , ,   .
  28.12.2006 [+]  .
  13.12.2006 [*]   .
  05.12.2006 [*]   .
  10.10.2006 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frAttributeEdit.pas,v 1.11 2012/10/25 10:54:22 tsk Exp $
=======================================================================================================================}
unit frAttributeEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB,
      StdCtrls, Mask, DBCtrls,
      // BASE:
      BASEfrEdit, BASEsfDBLookupCombo, BASEsfButtonEdit, BASEsfDBEdit,
      // Comming:
      CommingButton, CommingADO, CommingOther, CommingString;

type

  TFilmAttributeEditFR = class( TBASEEditFR )
    frGroup: TBASEDBLookupComboSF;
    taDataID: TAutoIncField;
    taDataFilm: TIntegerField;
    taDataAttribute: TIntegerField;
    frValue: TBASEDBLookupComboSF;
    taValue: TADODataSet;
    dsValue: TDataSource;
    frList: TBASEButtonEditSF;
    taDataAddition: TStringField;
    frAdd: TBASEDBEditSF;
    spVariant: TADOStoredProc;
    taCheck: TADODataSet;
    taCheckID: TIntegerField;
    taCheckFilm: TIntegerField;
    taCheckAttribute: TIntegerField;
    procedure frGroupcbFieldChange(Sender: TObject);
    procedure frGroupbtLabelClick(Sender: TObject);
    procedure frValuebtLabelClick(Sender: TObject);
    procedure frListbtLabelClick(Sender: TObject);
    procedure taDataAfterPost(DataSet: TDataSet);
    procedure taDataBeforePost(DataSet: TDataSet);
  private   { Private declarations }
    FVariant: String;
    procedure RefreshAttribute;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmAttributeEditFR; AOwner: TComponent; PAPost: TAfterPostKey;
                                            ID: Integer; Film: Integer = -1; Group: Integer = -1; Values: String = '*' );
  end;

implementation

uses dmCommingData, dmLookupComboData, fmAttributeGroup, fmAttributeValue, dmFindValue;

{$R *.DFM}
//======================================================================================================================
{ TFilmAttributeEditFR }
//======================================================================================================================
procedure TFilmAttributeEditFR.CheckRun( var AFrame: TFilmAttributeEditFR; AOwner: TComponent;
                                                      PAPost: TAfterPostKey; ID, Film, Group: Integer; Values: String );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TFilmAttributeEditFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    RequeryParameters( taData, [ ID ]);
    frGroup.RequeryLookup( dmCombo.dsAttribute );
    if ( Group > 0 ) then frGroup.cbField.KeyValue := Group;
    if ( Values <> '*' ) then frList.edData.Text := Values;
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataFilm.Value := Film;
    end;
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.frGroupcbFieldChange(Sender: TObject);
begin
  RequeryParameters( taValue, [ frGroup.cbField.KeyValue ]);
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.frGroupbtLabelClick(Sender: TObject);
begin
  inherited;
  FilmAttributeGroup( frGroup.cbField.KeyValue );
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.frValuebtLabelClick(Sender: TObject);
begin
  inherited;
  FilmAttributeValue( OwnerForm(Self), taDataAttribute, frGroup.cbField.KeyValue, RefreshAttribute );
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.RefreshAttribute;
begin
  frGroupcbFieldChange( self );
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.frListbtLabelClick(Sender: TObject);
  var d, v: Integer;
      s: String;
begin
  if Length( frList.edData.Text ) > 0 then begin
    d := Pos( ',', frList.edData.Text );
    if d > 0 then begin
      s := Copy( frList.edData.Text, 1, d - 1 );
      frList.edData.Text := Trim( Copy( frList.edData.Text, d + 1, MaxInt ));
    end else s := frList.edData.Text;
{    d := Pos ( '/', s );
    if d > 0 then begin
      e := Trim( Copy( s, d + 1, MaxInt ));
      s := Trim( Copy( s, 1, d - 1 ));
      d := Pos ( '/', e );
      if d > 0 then e := Trim( Copy( e, 1, d - 1 ));
      s := e + ' (' + s + ')';
    end;}
    FVariant := s;
    v := dmFind.FindAttributeValue( frGroup.cbField.KeyValue, s, ' [lst]' );
    frValue.RequeryLookup( dsValue );
    frValue.cbField.KeyValue := v;
  end;
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.taDataAfterPost(DataSet: TDataSet);
begin
  inherited;
  spVariant.Parameters[1].Value := taDataAttribute.Value;
  spVariant.Parameters[2].Value := FVariant;
  spVariant.ExecProc;
end;
//======================================================================================================================
procedure TFilmAttributeEditFR.taDataBeforePost( DataSet: TDataSet );
begin
  RequeryParameters( taCheck, [ taDataFilm.Value, taDataAttribute.Value ]);
  if taCheck.RecordCount > 0 then begin
    taData.Cancel;
    RequeryParameters( taData, [ taCheckID.Value ]);
  end;
  taCheck.Close;
  taData.Edit;
  inherited;
end;
//======================================================================================================================
end.
