/*=====================================================================================================================

   "Videoteq".

     .

=======================================================================================================================

  :

  24.10.2012 [*] FilmAttributeNoteUpdate:    ( ).
             [*] FilmAttributeSearch:    .
  07.10.2012 [+] FilmAttributeSearch:   .
             [+] VariantAttributeIsert:    .
  02.08.2007 [+] RangeFilmAttributeGroup:     .
             [*]   .
  08.07.2007 [+] AttributeValueUpdate:      .
  24.06.2007 [+] RangeFilmAttribute:    .
             [+] FilmAttributeGroupView:    .
  23.05.2007 [*]    .
             [*]     .
  15.01.2007 [+]  , , ,   .
  04.12.2006 [+]  .
  17.12.2004 [!]  .

=======================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scAttribute.sql,v 1.11 2012/10/24 11:52:22 tsk Exp $
=====================================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropView      'FilmAttributeGroupView'
EXECUTE CheckDropProcedure 'RangeFilmAttribute'
EXECUTE CheckDropProcedure 'RangeFilmAttributeGroup'

EXECUTE CheckDropProcedure 'FilmAttributeNoteUpdate'
EXECUTE CheckDropTrigger   'FilmNoteUpdate'
EXECUTE CheckDropTrigger   'AttributeFilmNoteUpdate'
EXECUTE CheckDropTrigger   'AttributeFilmNoteDelete'
EXECUTE CheckDropTrigger   'AttributeValueUpdate'

EXECUTE CheckDropProcedure 'VariantAttributeIsert'

EXECUTE CheckDropProcedure 'FilmAttributeSearch'
--
GO
--=====================================================================================================================
CREATE VIEW FilmAttributeGroupView
AS
  SELECT FilmAttribute.ID, FilmAttribute.Film, FilmAttribute.Attribute, 
         FilmAttribute.Addition, FilmAttribute.Range, 
         FilmAttributeGroup.ID AS GroupID, FilmAttributeGroup.Range AS GroupRange
    FROM FilmAttribute 
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID 
      INNER JOIN FilmAttributeGroup ON FilmAttributeValue.[Group] = FilmAttributeGroup.ID
--
GO
--=====================================================================================================================
CREATE PROCEDURE RangeFilmAttribute @ID INT, @Move INT
AS
  DECLARE @FL INT, @GR INT, @AT INT, @RN INT
  --  ,  , :
  SELECT @FL = Film, @GR = GroupID, @RN = [Range] FROM FilmAttributeGroupView WHERE (ID = @ID)
  -- :
  IF @Move < 0 SET @RN = @RN - 3
  IF @Move > 0 SET @RN = @RN + 3
  UPDATE FilmAttribute SET [Range] = @RN WHERE ID = @ID
  -- :
  DECLARE AttRange CURSOR FOR
    SELECT ID FROM FilmAttributeGroupView WHERE (Film = @FL) AND (GroupID = @GR) ORDER BY [Range]
  OPEN AttRange
  FETCH NEXT FROM AttRange INTO @AT
  SET @RN = 0
  WHILE @@FETCH_STATUS = 0 BEGIN
    UPDATE FilmAttribute SET [Range] = @RN WHERE ID = @AT
    FETCH NEXT FROM AttRange INTO @AT
    SET @RN = @RN + 2
  END
  CLOSE AttRange
  DEALLOCATE AttRange
--
GO
--=====================================================================================================================
CREATE PROCEDURE RangeFilmAttributeGroup @ID INT, @Move INT
AS
  DECLARE @RN INT, @SID INT 
  --  :
  SELECT @RN = [Range] FROM FilmAttributeGroup WHERE (ID = @ID)
  -- :
  IF @Move < 0 SET @RN = @RN - 3
  IF @Move > 0 SET @RN = @RN + 3
  UPDATE FilmAttributeGroup SET [Range] = @RN WHERE ID = @ID
  -- :
  DECLARE RangeSort CURSOR FOR
    SELECT ID FROM FilmAttributeGroup ORDER BY [Range]
  OPEN RangeSort
  FETCH NEXT FROM RangeSort INTO @SID
  SET @RN = 0
  WHILE @@FETCH_STATUS = 0 BEGIN
    UPDATE FilmAttributeGroup SET [Range] = @RN WHERE ID = @SID
    FETCH NEXT FROM RangeSort INTO @SID
    SET @RN = @RN + 2
  END
  CLOSE RangeSort
  DEALLOCATE RangeSort
--
GO
--=====================================================================================================================
CREATE PROCEDURE FilmAttributeNoteUpdate @FL INT
AS
  DECLARE @NT VARCHAR(MAX), @AT VARCHAR(MAX)
  SELECT @NT = CAST( Note AS VARCHAR(MAX)) FROM Film WHERE ID = @FL
  IF @NT IS NULL SET @NT = ''
  SET @AT = ''
  -- :
  DECLARE AttGroup CURSOR FOR
    SELECT DISTINCT FilmAttributeValue.[Group], 
					FilmAttributeGroup.Name, 
					ISNULL(FilmAttributeGroup.NameMany, FilmAttributeGroup.Name),
					FilmAttributeGroup.Range
      FROM FilmAttribute
        INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
        INNER JOIN FilmAttributeGroup ON FilmAttributeValue.[Group] = FilmAttributeGroup.ID
      WHERE (FilmAttribute.Film = @FL)
      ORDER BY FilmAttributeGroup.Range
  DECLARE @GI INT, @GN VARCHAR(100), @GNM VARCHAR(100), @GR INT, @MANY INT
  OPEN AttGroup
  FETCH NEXT FROM AttGroup INTO @GI, @GN, @GNM, @GR
  WHILE @@FETCH_STATUS = 0 BEGIN
--	SET @MANY = 1
	SELECT @MANY = COUNT(*)
	  FROM FilmAttribute INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
	  WHERE (FilmAttribute.Film = @FL) AND (FilmAttributeValue.[Group] = @GI)
	IF @MANY > 1 SET @AT = @AT + @GNM + ': '
	  ELSE 		 SET @AT = @AT + @GN + ': '
    -- :
--    BEGIN
      DECLARE AttValue CURSOR FOR
        SELECT FilmAttributeValue.ValueFull + ISNULL( '  ' + FilmAttribute.Addition, '') 
          FROM FilmAttribute
            INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
          WHERE (FilmAttribute.Film = @FL) AND (FilmAttributeValue.[Group] = @GI)
          ORDER BY FilmAttribute.Range DESC
      DECLARE @GV VARCHAR(100)
      OPEN AttValue
      FETCH NEXT FROM AttValue INTO @GV
      WHILE @@FETCH_STATUS = 0 BEGIN
        SET @AT = @AT + @GV + ', '
        FETCH NEXT FROM AttValue INTO @GV
      END
      CLOSE AttValue
      DEALLOCATE AttValue
--      SET @AT = @AT + CHAR(10) + CHAR(13)
      SET @AT = STUFF(@AT,LEN(@AT),1,'.') + CHAR(13)
--    END
    FETCH NEXT FROM AttGroup INTO @GI, @GN, @GNM, @GR
  END
  CLOSE AttGroup
  DEALLOCATE AttGroup
  --  
  IF (LEN(@AT)>0) SET @NT = @AT + CHAR(13) + @NT 
  UPDATE FILM SET DisplayNote = @NT WHERE ID = @FL
--
GO
--=====================================================================================================================
CREATE TRIGGER FilmNoteUpdate
  ON Film FOR UPDATE AS 
BEGIN

  IF UPDATE ( Note ) BEGIN
    DECLARE @ID INT
    SELECT @ID = ID FROM Inserted
    EXECUTE FilmAttributeNoteUpdate @ID
  END
END
--
GO
--=====================================================================================================================
CREATE TRIGGER AttributeFilmNoteUpdate
  ON FilmAttribute FOR INSERT, UPDATE AS 
BEGIN
  DECLARE @ID INT
  SELECT @ID = Film FROM Inserted
  EXECUTE FilmAttributeNoteUpdate @ID
END
--
GO
--=====================================================================================================================
CREATE TRIGGER AttributeFilmNoteDelete
  ON FilmAttribute FOR DELETE AS 
BEGIN
  DECLARE @ID INT
  SELECT @ID = Film FROM Deleted
  EXECUTE FilmAttributeNoteUpdate @ID
END
--
GO
--=====================================================================================================================
CREATE TRIGGER AttributeValueUpdate
  ON FilmAttributeValue FOR UPDATE AS 
BEGIN
  DECLARE @ID INT, @FL INT
  SELECT @ID = ID FROM Inserted
  DECLARE AttFilm CURSOR FOR
  SELECT FilmAttribute.Film
    FROM FilmAttributeValue 
      INNER JOIN FilmAttribute ON FilmAttributeValue.ID = FilmAttribute.Attribute
  WHERE (FilmAttributeValue.ID = @ID)
  OPEN AttFilm
  FETCH NEXT FROM AttFilm INTO @FL
  WHILE @@FETCH_STATUS = 0 BEGIN
    EXECUTE FilmAttributeNoteUpdate @FL
    FETCH NEXT FROM AttFilm INTO @FL
  END
  CLOSE AttFilm
  DEALLOCATE AttFilm
END
--
GO
--=====================================================================================================================
CREATE PROCEDURE VariantAttributeIsert @AT INT, @VR VARCHAR(300)
AS
  IF NOT EXISTS (SELECT ID FROM FilmAttributeValueVariant WHERE (Attribute = @AT) AND (Variant = @VR)) BEGIN
    DECLARE @GR INT
    SELECT  @GR = [Group] FROM FilmAttributeValue WHERE ( ID = @AT )
    INSERT INTO FilmAttributeValueVariant ( [Group], Attribute, Variant ) VALUES ( @GR, @AT, @VR )
  END
--
GO
--=====================================================================================================================
CREATE PROCEDURE FilmAttributeSearch @GR INT, @VR VARCHAR(300)
AS
  SELECT ID, Value FROM FilmAttributeValue WHERE ([Group] = @GR) AND (Value = @VR )
  --
  UNION
  --
  SELECT Attribute, Variant FROM FilmAttributeValueVariant WHERE ([Group] = @GR) AND (Variant = @VR )
  ---
  ORDER BY 1 DESC
--
GO
--=====================================================================================================================
-- 
--EXECUTE RangeFilmAttribute 672, -1
--EXECUTE RangeFilmAttributeGroup 27, 1
--EXECUTE FilmAttributeNoteUpdate 58
--EXECUTE VariantAttributeIsert 59, 'Test'
EXECUTE FilmAttributeSearch 1, ''


