/*=====================================================================================================================

   "Videoteq".

      -   .

=======================================================================================================================

  :

  29.01.2014 [+] HistoryMediumUpdate, HistoryMediumDelete:  .
             [*] HistoryUnitDelete:       .
  28.01.2014 [+] GridHistoryUnitMedium:   .
  26.01.2014 [+] HistoryMediumUnitInsertUpdate, HistoryMediumUnitDelete:   .
             [+] HistoryUnitInsert, HistoryUnitUpdate, HistoryUnitDelete:  .
             [+]  .
  17.12.2004 [!]  .

=======================================================================================================================
  Copyright 20042014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scFilmHistory.sql,v 1.2 2014/02/17 06:50:57 tsk Exp $
=====================================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropTrigger    'HistoryUnitInsert'
EXECUTE CheckDropTrigger    'HistoryUnitUpdate'
EXECUTE CheckDropTrigger    'HistoryUnitDelete'
EXECUTE CheckDropTrigger    'HistoryMediumUnitInsertUpdate'
EXECUTE CheckDropTrigger    'HistoryMediumUnitDelete'
EXECUTE CheckDropTrigger    'HistoryMediumUpdate'
EXECUTE CheckDropTrigger    'HistoryMediumDelete'
EXECUTE CheckDropProcedure  'GridHistoryUnitMedium'

--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryUnitInsert ON [Unit] FOR INSERT AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitProcedure, UnitValue)
    SELECT Inserted.Film, 'INS', ViewUnitDisplay.Display
      FROM Inserted
        INNER JOIN ViewUnitDisplay ON Inserted.ID = ViewUnitDisplay.ID
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryUnitUpdate ON [Unit] FOR UPDATE AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitProcedure, UnitValue, MediumValue)
    SELECT Inserted.Film, 'UPD', ViewUnitDisplay.Display, ViewMediumDisplay.Display
      FROM ViewUnitDisplay 
        INNER JOIN Inserted ON ViewUnitDisplay.ID = Inserted.ID 
        LEFT OUTER JOIN ViewMediumDisplay 
        INNER JOIN MediumUnit ON ViewMediumDisplay.ID = MediumUnit.Medium ON Inserted.ID = MediumUnit.Unit
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryUnitDelete ON [Unit] INSTEAD OF DELETE AS
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitProcedure, UnitValue, MediumValue)
    SELECT Deleted.Film, 'DEL', ViewUnitDisplay.Display, ViewMediumDisplay.Display
      FROM ViewUnitDisplay 
        INNER JOIN Deleted ON ViewUnitDisplay.ID = Deleted.ID 
        LEFT OUTER JOIN ViewMediumDisplay 
        INNER JOIN MediumUnit ON ViewMediumDisplay.ID = MediumUnit.Medium ON Deleted.ID = MediumUnit.Unit

  --INSERT INTO UnitMediumHistory (Video, UnitProcedure, UnitValue)
  --  SELECT Deleted.Film, 'DEL', ViewUnitDisplay.Display
  --    FROM Deleted
  --      INNER JOIN ViewUnitDisplay ON Deleted.ID = ViewUnitDisplay.ID

  DELETE FROM Unit WHERE (Unit.ID IN (SELECT ID FROM Deleted))
  --INSERT INTO UnitMediumHistory (Video, UnitProcedure, UnitValue)
  --  SELECT Deleted.Film, 'DEL', Deleted.Display
  --    FROM Deleted
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryMediumUnitInsertUpdate ON [MediumUnit] FOR INSERT, UPDATE AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitValue, MediumProcedure, MediumValue)
    SELECT ViewUnitDisplay.Film, ViewUnitDisplay.Display, 'MOV', ViewMediumDisplay.Display
      FROM Inserted 
        INNER JOIN ViewUnitDisplay ON Inserted.Unit = ViewUnitDisplay.ID 
        INNER JOIN ViewMediumDisplay ON Inserted.Medium = ViewMediumDisplay.ID
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryMediumUnitDelete ON [MediumUnit] FOR DELETE AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitValue, MediumProcedure, MediumValue)
    SELECT ViewUnitDisplay.Film, ViewUnitDisplay.Display, 'DEL', ViewMediumDisplay.Display
      FROM Deleted
        INNER JOIN ViewUnitDisplay ON Deleted.Unit = ViewUnitDisplay.ID 
        INNER JOIN ViewMediumDisplay ON Deleted.Medium = ViewMediumDisplay.ID
--  DELETE FROM MediumUnit WHERE (MediumUnit.ID IN (SELECT ID FROM Deleted))
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryMediumUpdate ON [Medium] FOR UPDATE AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitValue, MediumProcedure, MediumValue)
    SELECT Unit.Film, ViewUnitDisplay.Display, 'UPD' AS Expr1, ViewMediumDisplay.Display AS Expr2
      FROM Inserted
        INNER JOIN MediumUnit ON Inserted.ID = MediumUnit.Medium 
        INNER JOIN Unit ON MediumUnit.Unit = Unit.ID 
        INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
        INNER JOIN ViewMediumDisplay ON Inserted.ID = ViewMediumDisplay.ID
END
--
GO
--=====================================================================================================================
CREATE TRIGGER HistoryMediumDelete ON [Medium] INSTEAD OF DELETE AS 
BEGIN
  INSERT INTO UnitMediumHistory (Video, UnitValue, MediumProcedure, MediumValue)
    SELECT Unit.Film, ViewUnitDisplay.Display, 'DEL', ViewMediumDisplay.Display
      FROM Deleted
        INNER JOIN MediumUnit ON Deleted.ID = MediumUnit.Medium 
        INNER JOIN Unit ON MediumUnit.Unit = Unit.ID 
        INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
        INNER JOIN ViewMediumDisplay ON Deleted.ID = ViewMediumDisplay.ID
  DELETE FROM Medium WHERE (Medium.ID IN (SELECT ID FROM Deleted))
END
--
GO
--=====================================================================================================================
CREATE PROCEDURE GridHistoryUnitMedium @FL INT
AS
  SELECT CONVERT(varchar, Point, 104) + CHAR(10) + LEFT(CONVERT(varchar, Point, 8), 5) AS Point,
         ISNULL(UnitProcedure, ' - ') + CHAR(10) + ISNULL(MediumProcedure, ' - ') AS [Procedure], 
         ISNULL(UnitValue, '') + CHAR(10) + ISNULL(MediumValue,'') AS Value
    FROM UnitMediumHistory
    WHERE (Video = @FL)
    ORDER BY UnitMediumHistory.Point DESC, ID DESC
--
GO
--=====================================================================================================================
-- 
-- 2359 = No Country for Old Men (   )  2007  
-- 3021 = Hadaka no Shima  ( )  1960  
--  467 = We Will Rock You: Queen Live in Concert  1981   
EXECUTE GridHistoryUnitMedium 467
