{===================================================================================================

   "Videoteq".

     ( ), , .

====================================================================================================

  :

  09.10.2009 [*]    ""   .
  08.10.2009 [*]    MediaInfo.dll.
  07.10.2009 [+]  MediaInfo.dll.
  19.08.2008 [*]    .
  01.08.2008 [*]  AVI  ,   .
  06.06.2008 [*]  - -.
  20.05.2008 [*]   -.
  16.05.2008 [+]    -.
  01.09.2007 [+]   .
  20.08.2007 [+]    -  -.
  12.08.2007 [+]  -.
  23.03.2007 [*]     .
  12.01.2007 [+]  .
             [*]    "".
             [*]    "".
  05.05.2005 [+]   "".
             [+]   "".
  13.04.2005 [*]    .
             [+]  -.
  17.03.2005 [+]  -.
             [+]   .
             [*] .
  15.03.2005 [+] .
  14.03.2005 [*]      .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042009 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: frUnitEdit.pas,v 1.1 2010/01/19 09:46:50 tsk Exp $
===================================================================================================}
unit frUnitEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB,
      StdCtrls, Mask, DBCtrls, DateUtils{, MMSystem}, MediaInfoDLL,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo, BASEsfDBEditDBEdit, BASEsfBevel,
      BASEsfLabelBevel, BASEsfDBEditComboBox,
      // Comming:
      CommingButton, CommingADO, CommingString, CommingFile, CommingOther,
  BASEsfBevelDBLookupCombo, Menus;

type

  TUnitEditFR = class( TBASEEditFR )
    frResolution: TBASEDBEditSF;
    frPlaytime: TBASEDBEditSF;
    frVideoCodec: TBASEDBLookupComboSF;
    frNote: TBASEDBEditDBEditSF;
    taDataID: TAutoIncField;
    taDataFilm: TIntegerField;
    taDataResolution: TStringField;
    taDataPlaytime: TStringField;
    taDataNote: TStringField;
    frSize: TBASEDBEditComboBoxSF;
    taDataOrder: TIntegerField;
    taDataCodecVideo: TSmallintField;
    taDataCodecAudio: TSmallintField;
    taDataSize: TLargeintField;
    frVideo: TBASELabelBevelSF;
    frAudioCodec: TBASEDBLookupComboSF;
    frAudioBitrate: TBASEDBEditSF;
    frOther: TBASEBevelSF;
    frVideoBitrate: TBASEDBEditSF;
    taDataBitrateVideo: TIntegerField;
    taDataBitrateAudio: TIntegerField;
    btFile: TcoButton;
    frSoundChoice: TBASEBevelDBLookupComboSF;
    frAudioKind: TBASEDBLookupComboSF;
    procedure frCodecbtLabelClick(Sender: TObject);
    procedure frResolutionedFieldChange(Sender: TObject);
    procedure frSizeedFieldChange(Sender: TObject);
    procedure frAudioCodecbtLabelClick(Sender: TObject);
    procedure taDataBeforePost(DataSet: TDataSet);
    procedure btFileClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
  private   { Private declarations }
    FFile: String;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TUnitEditFR; AOwner: TComponent; PAPost: TAfterPostKey;
                        ID: Integer; Film: Integer = -1; VFile: String = '*' );
  end;

implementation

uses dmCommingData, dmLookupComboData, fmCodec, dmFindValue, StrUtils;

{$R *.DFM}
//==================================================================================================
{ TUnitEditFR }
//==================================================================================================
procedure TUnitEditFR.CheckRun( var AFrame: TUnitEditFR; AOwner: TComponent;
                                     PAPost: TAfterPostKey; ID, Film: Integer; VFile: String );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TUnitEditFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    FFile := VFile;
    RequeryParameters( taData, [ ID ]);
    frVideoCodec.RequeryLookup( dmCombo.dsCodecVideo );
    RequeryParameters( frSoundChoice.taChoice, [ ID ]);
    frSoundChoice.cbField.KeyValue := frSoundChoice.taChoice.FieldValues['ID'];
    frAudioKind.RequeryLookup( dmCombo.dsUnitKind );
    frAudioCodec.RequeryLookup( dmCombo.dsCodecAudio );


    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataFilm.Value := Film;
    end;
    btFile.Enabled := ( VFile <> '*' );
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TUnitEditFR.frCodecbtLabelClick(Sender: TObject);
begin
  inherited;
  CodecQuery( OwnerForm(Self), taDataCodecVideo );
end;
//==================================================================================================
procedure TUnitEditFR.frResolutionedFieldChange( Sender: TObject );
  var H, W, p: Integer;
      R: Real;
      S: String;
begin
  with frResolution.edField do begin
    OnChange := nil;
    S := DelChar( Text, #32 );
    p := Pos( 'x', S );
    W := StrToIntDef( Copy( S, 1, p-1), 0);
    H := StrToIntDef( Copy( S, p+1, 4), 0);
    if ( H = 0 ) then H := StrToIntDef( Copy( S, p+1, 3), 0);
    if not (( H = 0 ) or ( W = 0 )) then begin
      R := ( W / H );
      S := Format( '%dx%d %s', [ W, H, iif( R < 14/9, '(4:3)', '(16:9)')]);
      if ( S <> Text ) then SetField( Field, S )
    end
  end;
  frResolution.edField.OnChange := frResolutionedFieldChange;
end;
//==================================================================================================
procedure TUnitEditFR.frSizeedFieldChange(Sender: TObject);
begin
  with frSize.edField do begin
    OnChange := nil;
    Text := DelChar( Text, #32 );
    Text := DelChar( Text, ',' );
  end;
  frSize.edField.OnChange := frSizeedFieldChange;
end;
//==================================================================================================
procedure TUnitEditFR.frAudioCodecbtLabelClick(Sender: TObject);
begin
  inherited;
  CodecQuery( OwnerForm(Self), taDataCodecAudio );
end;
//==================================================================================================
procedure TUnitEditFR.taDataBeforePost(DataSet: TDataSet);
begin
  inherited;
  case frSize.cbField.ItemIndex of
    1: taDataSize.Value := taDataSize.Value * 1024;
    2: taDataSize.Value := taDataSize.Value * 1024 * 1024;
    3: taDataSize.Value := taDataSize.Value * 1024 * 1024 * 1024;
  end;
  frSize.cbField.ItemIndex := 0;
end;
//==================================================================================================
procedure TUnitEditFR.btSaveClick(Sender: TObject);
begin
  frSoundChoice.Post;
  inherited;
end;
//==================================================================================================
//   MediaInfo.dll
//==================================================================================================
procedure TUnitEditFR.btFileClick( Sender: TObject );
  var Handle: Cardinal;
  function GetMediaInfoStr( Kind: TMIStreamKind; Parameter: PChar ): String;
  begin
    Result := MediaInfoA_Get(Handle, Kind, 0, Parameter, Info_Text, Info_Name);
  end;
  function GetMediaInfoInt( Kind: TMIStreamKind; Parameter: PChar ): Int64;
  begin
    Result := StrToInt64Def( MediaInfoA_Get(Handle, Kind, 0, Parameter, Info_Text, Info_Name), 0);
  end;
begin
  if FFile = '*' then Exit;
  Screen.Cursor := crHourGlass;
  taData.Edit;
  if LibHandle = 0 then MediaInfoDLL_Load( 'MediaInfo.dll' );
  Handle := MediaInfo_New();
  MediaInfo_Option (0, 'Complete', '');
  if MediaInfoA_Open( Handle, PChar(FFile)) = 1 then begin
    // VIDEO:
    taDataCodecVideo.Value    := dmFind.FindFCC( GetMediaInfoStr( Stream_Video, 'CodecID' ));
    taDataResolution.Value    := GetMediaInfoStr( Stream_Video, 'Width' )
                                 + 'x' + GetMediaInfoStr( Stream_Video, 'Height' );
    taDataBitrateVideo.Value  := Round( GetMediaInfoInt( Stream_Video, 'BitRate' )/ 1000 );
    // AUDIO:
    taDataCodecAudio.Value    := dmFind.FindFCC( GetMediaInfoStr( Stream_Audio, 'CodecID' ));
    taDataBitrateAudio.Value  := GetMediaInfoInt( Stream_Audio, 'BitRate' ) div 1000;
    // FILE:
    taDataPlaytime.Value      := LeftStr( GetMediaInfoStr( Stream_General, 'Duration/String3' ), 8 );
    frSize.cbField.ItemIndex  := 0;
    taDataSize.Value          := GetMediaInfoInt(Stream_General, 'FileSize');
  end;
  MediaInfo_Close(Handle);
  Screen.Cursor := crDefault;
end;
//==================================================================================================
//   Win32 multimedia API
//==================================================================================================
{procedure TUnitEditFR.btFileClick( Sender: TObject );
  var pFile: PAVIFile;
      AVIInfo: TAVIFILEINFOW;
      AVIStream: PAVIStream;
      AVISInfo: TAVISTREAMINFO;
      AVIWavInfo : PWaveFormat;
      AVIVideoInfo: PBitmapInfoHeader;
      hSize: DWORD;
      sTime: Extended;
      i, sBit: Integer;
  function FCCtoStr( C: DWORD ): String;
  begin
    if C > 0
      then Result := UpperCase( Char(C) + Char(C shr 8) + Char(C shr 16) + Char(C shr 24))
      else Result := 'MPG4';
  end;
begin
  Screen.Cursor := crHourGlass;
  if FFile = '*' then Exit;

  taData.Edit;

  try

  // Initialize the AVIFile library.
  AVIFileInit;

  // The AVIFileOpen function opens an AVI file
  AVIFileOpen( pFile, PChar( FFile ), 0, nil );

  // AVIFileInfo obtains information about an AVI file
  AVIFileInfo(pFile, @AVIInfo, SizeOf(AVIInfo));
  sTime := AVIInfo.dwLength * ( AVIInfo.dwScale / AVIInfo.dwRate );

  // Open a VIDEO-Stream from the file
  AVIFileGetStream ( pFile, AVIStream, streamtypeVIDEO, 0 );
  AVIStreamInfo ( AVIStream, @AVISInfo, SizeOf(AVISInfo));
  // Format:
  AVIStreamReadFormat ( AVIStream, 0, nil, @hSize );
  GetMem (AVIVideoInfo, hSize);
  AVIStreamReadFormat (AVIStream, 0, AVIVideoInfo, @hSize);
  AVIStreamRelease (AVIStream);

  // Open a AUDIO-Stream from the file
  AVIFileGetStream ( pFile, AVIStream, streamtypeAUDIO, 0 );
  // Format:
  AVIStreamReadFormat ( AVIStream, 0, nil, @hSize );
  GetMem (AVIWavInfo, hSize);
  AVIStreamReadFormat (AVIStream, 0, AVIWavInfo, @hSize);
  AVIStreamRelease (AVIStream);

  // VIDEO:
  taDataCodecVideo.Value    := dmFind.FindFCC( FCCtoStr( AVISInfo.fccHandler ));
  taDataResolution.Value    := IntToStr( AVIINFO.dwWidth ) + 'x' + IntToStr( AVIINFO.dwHeight );
  // AUDIO:
  taDataCodecAudio.Value    := dmFind.FindFCC( IntToHex(AVIWavInfo.wFormatTag, 4 ));
  taDataBitrateAudio.Value  := ( AVIWavInfo.nAvgBytesPerSec * 8) div 1000;
  // FILE:
  taDataPlaytime.Value      := TimeToStr( sTime / SecsPerDay );
  frSize.cbField.ItemIndex  := 0;

  // VIDEO-Bitrate:
  sBit := 0;
  for i := 0 to AVIInfo.dwStreams -  1  do begin
    AVIFileGetStream ( pFile, AVIStream, 0, i );
    AVIStreamInfo ( AVIStream, @AVISInfo, SizeOf(AVISInfo));
    if AVISInfo.fccType = streamtypeAUDIO then begin
      AVIStreamReadFormat ( AVIStream, 0, nil, @hSize );
      GetMem (AVIWavInfo, hSize);
      AVIStreamReadFormat (AVIStream, 0, AVIWavInfo, @hSize);
      AVIStreamRelease (AVIStream);
      sBit := sBit + AVIWavInfo.nAvgBytesPerSec;
    end;
  end;

  AVIFileRelease(pFile);
  AVIFileExit;

  taDataSize.Value         := TakeFileSize( FFile );
  taDataBitrateVideo.Value := Round((( taDataSize.Value / sTime ) - sBit) * 8 / 1000 );

  except

    taDataCodecVideo.Clear;
    taDataCodecAudio.Clear;
    taDataSize.Value         := TakeFileSize( FFile );

  end;

  Screen.Cursor := crDefault;

end;}
//==================================================================================================
end.
