/*=================================================================================================

   "Videoteq".

    .

===================================================================================================

  :

  10.12.2009 [+] LookupUnitAudio:    .
  23.06.2007 [*] InfoUnit:  ViewUnitDisplay.
  23.03.2005 [*] InfoUnit:    .
  15.03.2005 [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042009 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scUnit.sql,v 1.6 2009/12/10 12:39:04 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'InfoUnit'
EXECUTE CheckDropProcedure 'LookupMedium'
EXECUTE CheckDropProcedure 'LookupUnitAudio'
--
GO
--=================================================================================================
CREATE PROCEDURE InfoUnit @ID INT
AS
  SELECT Unit.ID,
         ViewUnitDisplay.Display AS UnitName
    FROM Unit
      INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
    WHERE (Unit.ID = @ID)
--
GO
--=================================================================================================
CREATE PROCEDURE LookupMedium
AS
  SELECT Medium.ID,
         Medium.Number 
           + ' [' + MediumKind.Name + '] ' 
           + Place.Display AS MediumName
    FROM Medium
      INNER JOIN MediumKind ON Medium.Kind = MediumKind.ID
      INNER JOIN Place ON Medium.Place = Place.ID
    ORDER BY Medium.Number
--
GO
--=================================================================================================
CREATE PROCEDURE LookupUnitAudio @UN INT
AS
  SELECT UnitAudio.ID, 
         UnitAudio.Number, 
         UnitAudio.Kind, 
         UnitAudio.Codec, 
         UnitAudio.Bitrate, 
         CAST(UnitAudio.Number AS VARCHAR) + ': ' + ISNULL(UnitKind.Name, '()') AS DisplayName
    FROM UnitAudio 
      LEFT OUTER JOIN UnitKind ON UnitAudio.Kind = UnitKind.ID
    WHERE (UnitAudio.Unit = @UN)  
--
GO
--=================================================================================================
-- 
--EXECUTE InfoUnit 268
--EXECUTE LookupMedium 
EXECUTE LookupUnitAudio 3
