{===================================================================================================

   "Videoteq".

    ,      xml-.

====================================================================================================

  :

  23.06.2007 [*] ImportXMLFilmUnit:  audio.
  23.06.2007 [*] ImportXMLFilmUnit:    .
  27.03.2007 [+] ImportXMLFilmAttribute:  .
  13.01.2007 [*] :      .
  12.01.2007 [*]  ,     .
  11.01.2007 [-]      .
             [*]       .
  27.12.2006 [+]    ,  ,   .
  26.12.2006 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: dmXML.pas,v 1.13 2008/09/23 06:15:21 tsk Exp $
===================================================================================================}
unit dmXML;

interface

uses  SysUtils, Classes, MidasLib, ADODB, Provider, DB, DBClient, Forms, Dialogs, Variants,
      // Comming:
      CommingADO, CommingString;

type
  TdmXMLFilm = class(TDataModule)
    taXML: TClientDataSet;
    dsXML: TDataSetProvider;
    taFilm: TADODataSet;
    taAttrib: TADODataSet;
    taFilmGroup: TStringField;
    taFilmArticle: TStringField;
    taFilmName: TStringField;
    taFilmNameTranslat: TStringField;
    taFilmYear: TSmallintField;
    taFilmCountry: TStringField;
    taFilmAddition: TStringField;
    taFilmCover: TBlobField;
    taFilmNote: TMemoField;
    taFilmRange: TStringField;
    taUnit: TADODataSet;
    taImport: TClientDataSet;
    dgImport: TOpenDialog;
    taFilmKind: TADODataSet;
    taFilmKindKind: TStringField;
    taFilmKindName: TStringField;
    taFilmKindOrder: TSmallintField;
    taFilmKindNeedAdd: TBooleanField;
    taFilmImport: TADODataSet;
    taFilmImportID: TAutoIncField;
    taFilmImportGroup: TStringField;
    taFilmImportArticle: TStringField;
    taFilmImportName: TStringField;
    taFilmImportNameTranslat: TStringField;
    taFilmImportYear: TSmallintField;
    taFilmImportCountry: TStringField;
    taFilmImportAddition: TStringField;
    taFilmImportCover: TBlobField;
    taFilmImportNote: TMemoField;
    taFilmImportRange: TStringField;
    taFilmImportDisplayNote: TMemoField;
    taFilmUnit: TADODataSet;
    taFilmUnitFilm: TIntegerField;
    taFilmUnitResolution: TStringField;
    taFilmUnitPlaytime: TStringField;
    taFilmUnitNote: TStringField;
    taFilmAttribute: TADODataSet;
    taFilmAttributeID: TAutoIncField;
    taFilmAttributeFilm: TIntegerField;
    taFilmAttributeAttribute: TIntegerField;
    taFilmAttributeAddition: TStringField;
    taFilmUnitCodecVideo: TSmallintField;
    taFilmUnitBitrateVideo: TIntegerField;
    taFilmUnitCodecAudio: TSmallintField;
    taFilmUnitBitrateAudio: TIntegerField;
    taFilmUnitSize: TLargeintField;
    taFilmUnitOrder: TIntegerField;
  private   { Private declarations }
  public    { Public declarations }
    procedure ExportXLM( Film: Integer );
    procedure ImportXML;
    function  ImportXMLFilm( XML: String = '*'): Integer;
    procedure ImportXMLFilmAttribute( Film: Integer; XML: String = '*' );
    procedure ImportXMLFilmUnit( Film: Integer; XML: String = '*' );
  end;

var dmXMLFilm: TdmXMLFilm;

implementation

uses dmCommingData, fmFilm, dmFindValue;
{$R *.dfm}
//==================================================================================================
{ TdmXMLFilm }
//==================================================================================================
procedure TdmXMLFilm.ExportXLM( Film: Integer );
  var f: String;
begin
  // :
  RequeryParameters( taFilm, [ Film ]);
  f := DeleteChars( taFilmName.Value, ':\/' );
  f := ExtractFilePath( Application.ExeName ) + f + '.';
  dsXML.DataSet := taFilm;
  taXML.Open;
  taXML.SaveToFile( f + 'xml', dfXMLUTF8);
  taXML.Close;
  // :
  RequeryParameters( taAttrib, [ Film ]);
  dsXML.DataSet := taAttrib;
  taXML.Open;
  taXML.SaveToFile( f + 'attr.xml', dfXMLUTF8);
  taXML.Close;
  // :
  RequeryParameters( taUnit, [ Film ]);
  dsXML.DataSet := taUnit;
  taXML.Open;
  taXML.SaveToFile( f + 'unit.xml', dfXMLUTF8);
  taXML.Close;
end;
//==================================================================================================
procedure TdmXMLFilm.ImportXML;
  var f: String;
      Film: Integer;
begin
    // :
    Film := ImportXMLFilm( '*' );
    if Film < 0 then Exit;
    f := ChangeFileExt( dgImport.FileName, '.attr.xml' );
    ImportXMLFilmAttribute( Film, f );
    // :
    f := ChangeFileExt( dgImport.FileName, '.unit.xml' );
    ImportXMLFilmUnit( Film, f );
    //    :
    FilmDeman( Film );
end;
//==================================================================================================
function TdmXMLFilm.ImportXMLFilm( XML: String ): Integer;
  var Kind: Variant;
begin
  Result := -1;
  if XML = '*'
    then if dgImport.Execute
           then XML := dgImport.FileName
           else Exit;
  taImport.LoadFromFile( dgImport.FileName );
  taImport.Open;
  //   .
  Kind := SQLCalculate( dmComming.cnVideo, sqlFindKind, [taImport.FieldValues['Group']] );
  if Kind = Null then begin
    Kind := taImport.FieldValues['Group'];
    taFilmKind.Open;
    taFilmKind.Insert;
    taFilmKindKind.Value := Kind;;
    taFilmKindName.Value := '[   ]';
    taFilmKind.Post;
    taFilmKind.Close;
  end;
    //   :
  taFilmImport.Open;
  taFilmImport.Insert;
  taFilmImportGroup.Value             := taImport.FieldValues['Group'];
  SetField( taFilmImportArticle,      taImport.FieldValues['Article']);
  taFilmImportName.Value              := taImport.FieldValues['Name'];
  SetField( taFilmImportNameTranslat, taImport.FieldValues['NameTranslat']);
  SetField( taFilmImportYear,         taImport.FieldValues['Year']);
  SetField( taFilmImportCountry,      taImport.FieldValues['Country']);
  SetField( taFilmImportAddition,     taImport.FieldValues['Addition']);
  taFilmImportAddition.AsString       := taFilmImportAddition.AsString + '[xml]';
  taFilmImportCover.Value             := taImport.FieldValues['Cover'];
  taFilmImportNote.Value              := taImport.FieldValues['Note'];
  taFilmImportDisplayNote.Value       := taImport.FieldValues['Note'];
  SetField( taFilmImportRange,        taImport.FieldValues['Range']);
  taFilmImport.Post;
  Result := taFilmImportID.Value;
  taFilmImport.Close;
  taImport.Close;
end;
//==================================================================================================
procedure TdmXMLFilm.ImportXMLFilmAttribute( Film: Integer; XML: String );
  var ag, av: Integer;
      ad: Variant;
begin
  if XML = '*'
    then if dgImport.Execute
           then XML := dgImport.FileName
           else Exit;
  taImport.LoadFromFile( XML );
  taImport.Open;
  while not taImport.Eof do begin
    // :
    ag := dmFind.FindAttributeGroup( taImport.FieldValues['AttributeGroup'], ' [xml]' );
    av := dmFind.FindAttributeValue( ag, taImport.FieldValues['AttributeValue'], ' [xml]' );
    ad := taImport.FieldValues['AttributeAddition'];
    taFilmAttribute.Open;
    taFilmAttribute.Insert;
    taFilmAttributeFilm.Value       := Film;
    taFilmAttributeAttribute.Value  := av;
    if ad <> null then taFilmAttributeAddition.Value := ad;
    taFilmAttribute.Post;
    taFilmAttribute.Close;
    taImport.Next;
  end;
  taImport.Close;
end;
//==================================================================================================
procedure TdmXMLFilm.ImportXMLFilmUnit(Film: Integer; XML: String);
  var cv, ca, p: Integer;
      sz: String;
begin
  if XML = '*'
    then if dgImport.Execute
           then XML := dgImport.FileName
           else Exit;
  taImport.LoadFromFile( XML );
  taImport.Open;
  while not taImport.Eof do begin
    //  :
    cv := dmFind.FindCodec( taImport.FieldValues['CodecVideo'], ' [xml]');
    ca := dmFind.FindCodec( taImport.FieldValues['CodecAudio'], ' [xml]');
    taFilmUnit.Open;
    taFilmUnit.Insert;
    taFilmUnitFilm.Value              := Film;
    taFilmUnitCodecVideo.Value        := cv;
    SetField( taFilmUnitResolution,   taImport.FieldValues['Resolution']);
    SetField( taFilmUnitBitrateVideo, taImport.FieldValues['BitrateVideo']);
    if ca > 0
      then taFilmUnitCodecAudio.Value := ca;
    SetField( taFilmUnitBitrateAudio, taImport.FieldValues['BitrateAudio']);
    SetField( taFilmUnitPlaytime,     taImport.FieldValues['Playtime']);
    // :
    if ( taImport.FindField('Size') is TStringField ) then begin
      sz := taImport.FieldValues['Size'];
      p := Pos( 'M', sz );
      if p > 0 then sz := Copy( sz, 1, p - 1 );
      SetField( taFilmUnitSize,     StrToInt( sz ) * 1024 * 1024 );
    end else begin
      SetField( taFilmUnitSize,     taImport.FieldValues['Size']);
    end;
    SetField( taFilmUnitNote,       taImport.FieldValues['Note']);
    taFilmUnit.Post;
    taFilmUnit.Close;
    taImport.Next;
    end;
  taImport.Close;
end;
//==================================================================================================
end.
