{=======================================================================================================================

   "Videoteq".

    ,  , , .

========================================================================================================================

  :

  28.01.2014 [*] .
             [*]     .
             [*]        448.
  27.01.2014 [*]   .
  23.10.2012 [+]     www.kinopoisk.ru.
  22.08.2007 [+]  .
  12.01.2007 [+]         .
             [+]    .
  13.12.2006 [*]  .
  14.10.2005 [+]    .
  25.07.2005 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frFilmAddition.pas,v 1.10 2014/01/30 01:22:21 tsk Exp $
=======================================================================================================================}
unit frFilmAddition;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB, StdCtrls, Mask,
      DBCtrls, PropFilerEh, PropStorageEh, Word2000, OleServer, Variants,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo,
      // Comming:
      CommingButton, CommingOther, CommingADO, CommingString, CommingFlat, CommingDBImage,
      // Videoteq:
      frFilmAdditionSearchWeb;

type

  TFilmEditAdditionFR = class( TBASEEditFR )
    taDataID: TAutoIncField;
    frFirstName: TBASEDBEditSF;
    edCover: TcoDBImage;
    taDataCover: TBlobField;
    taDataNote: TMemoField;
    meNote: TcoDBMemo;
    btLoad: TcoButton;
    opPicture: TOpenDialog;
    psFrame: TPropStorageEh;
    btExport: TcoButton;
    svPicture: TSaveDialog;
    btSpelling: TcoButton;
    oleWordApp: TWordApplication;
    oleWordDoc: TWordDocument;
    btSearch: TcoButton;
    taDataNameInternet: TStringField;
    procedure btLoadClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btExportClick(Sender: TObject);
    procedure edCoverEnter(Sender: TObject);
    procedure edCoverExit(Sender: TObject);
    procedure meNoteEnter(Sender: TObject);
    procedure meNoteExit(Sender: TObject);
    procedure btSpellingClick(Sender: TObject);
    procedure btSearchClick(Sender: TObject);
  private   { Private declarations }
    FNoteSearch: TFilmNoteSearchWebFR;
    procedure SetNote( Note: String );
    procedure SetSize;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmEditAdditionFR; AOwner: TComponent; PAPost: TAfterPostKey;
                        ID: Integer );
  end;

implementation

uses dmCommingData, BASEdmData;

{$R *.DFM}
//======================================================================================================================
{ TFilmEditAdditionFR }
//======================================================================================================================
procedure TFilmEditAdditionFR.CheckRun( var AFrame: TFilmEditAdditionFR; AOwner: TComponent;
                                                                                   PAPost: TAfterPostKey; ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TFilmEditAdditionFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    RequeryParameters( taData, [ ID ]);
    psFrame.LoadProperties;
    if taData.RecordCount > 0 then begin
      ShowModal;
      SetSize;
      edCover.SetFocus;
    end;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.SetSize;
begin
  if taDataCover.IsNull then begin
    edCover.Width := 336;
    edCover.Color := clWindow;
  end else begin
    edCover.Width := edCover.Picture.Width + 8;
    if edCover.Picture.Height = 448 then edCover.Color := clWindow else edCover.Color := clMoneyGreen;
  end;
  meNote.Left   := edCover.Left + edCover.Width + 4;
  meNote.Width  := Self.ClientWidth - meNote.Left - 4;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.edCoverEnter(Sender: TObject);
begin
  btLoad.Enabled    := True;
  btExport.Enabled  := True;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.edCoverExit(Sender: TObject);
begin
  btLoad.Enabled    := False;
  btExport.Enabled  := False;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.btLoadClick(Sender: TObject);
begin
  if opPicture.Execute then begin
    if taData.State <> dsInsert then taData.Edit;
    taDataCover.LoadFromFile( opPicture.FileName );
    SetSize;
  end;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.btExportClick(Sender: TObject);
begin
  svPicture.FileName := taDataNameInternet.Value;
  if svPicture.Execute then taDataCover.SaveToFile( svPicture.FileName );
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.btSaveClick(Sender: TObject);
begin
  psFrame.SaveProperties;
  inherited;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.meNoteEnter(Sender: TObject);
begin
  btSpelling.Enabled := True;
  btSearch.Enabled   := True;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.meNoteExit(Sender: TObject);
begin
  btSpelling.Enabled := False;
  btSearch.Enabled   := False;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.btSpellingClick(Sender: TObject);
  var varFalse : OleVariant;
      Old: String;
begin
  Old := meNote.Text;
  oleWordApp.Connect;
  oleWordDoc.ConnectTo( oleWordApp.Documents.AddOld( EmptyParam, EmptyParam ));
  oleWordDoc.Range.Delete( EmptyParam, EmptyParam );
  oleWordDoc.Range.Set_Text( Old );
  oleWordDoc.CheckSpelling;
  if Old <> oleWordDoc.Range.Get_Text then begin
    if not ( dsData.State in [dsEdit, dsInsert ]) then taData.Edit;
    meNote.Text := oleWordDoc.Range.Get_Text;
  end;
  oleWordApp.Quit( varFalse );
  oleWordApp.Disconnect;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.SetNote(Note: String);
begin
  if taDataNote.Value <> Note then begin
    if not ( dsData.State in [dsEdit, dsInsert ]) then taData.Edit;
    meNote.Text := Note;
  end;
end;
//======================================================================================================================
procedure TFilmEditAdditionFR.btSearchClick(Sender: TObject);
begin
  FNoteSearch.CheckRun( FNoteSearch, Owner, SetNote, taDataNameInternet.Value );
end;
//======================================================================================================================
end.
