{=======================================================================================================================

   "Videoteq".

    , , .

========================================================================================================================

  :

  31.15.2015 [*]    Videoteq.XE.
  17.10.2012 [+] :  .
  16.10.2012 [+]    www.kinopoisk.ru.
             [*]      .
  26.09.2012 [+]   .
  18.01.2011 [*]  ViewFilmDisplay.
  19.04.2009 [*]   .
  30.08.2008 [+]  .
             [+]   .
  13.08.2007 [+]  .
  09.08.2007 [+] .
  10.10.2006 [+]    .
  05.04.2006 [+]  .
  23.09.2005 [+] .
  25.07.2005 [+]     .
             [-]   ""  "".
  17.03.2005 [*]  -.
  09.03.2005 [*]      .
  04.03.2005 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frFilmEdit.pas,v 1.17 2015/03/31 03:39:50 tsk Exp $
=======================================================================================================================}
unit frFilmEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ADODB, ExtCtrls, DB, StdCtrls, Mask,
      DBCtrls, Clipbrd,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo, BASEsfDBEditDBEdit,
      // Comming:
      CommingButton, CommingOther, CommingADO, CommingString,
      // Videoteq:
      frFilmEditSearchWeb;

type

  TFilmEditFR = class( TBASEEditFR )
    frName: TBASEDBEditSF;
    frTranslat: TBASEDBEditSF;
    frAddOn: TBASEDBEditSF;
    bvGenre: TBevel;                
    frGenre: TBASEDBLookupComboSF;
    taGenre: TADODataSet;
    dsGenre: TDataSource;
    taDataID: TAutoIncField;
    taDataGroup: TStringField;
    taDataName: TStringField;
    taDataNameTranslat: TStringField;
    taDataAddition: TStringField;
    btReg: TcoButton;
    frArticle: TBASEDBEditSF;
    frRange: TBASEDBEditSF;
    frYearCountry: TBASEDBEditDBEditSF;
    taDataYear: TSmallintField;
    taDataCountry: TStringField;
    frHigh: TBASEDBLookupComboSF;
    taDataHeading: TIntegerField;
    taHigh: TADODataSet;
    dsHigh: TDataSource;
    taDataArticle: TStringField;
    btPast: TcoButton;
    btSearch: TcoButton;
    taDataRangeD7: TStringField;
    procedure btRegClick(Sender: TObject);
    procedure Paste( Text: String );
    procedure btPastClick(Sender: TObject);
    procedure btSearchClick(Sender: TObject);
  private    { Private declarations }
    FSearch: TFilmEditSearchWebFR;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmEditFR; AOwner: TComponent; PAPost: TAfterPostKey; ID: Integer;
                                                        FName: String = '*'; Group: String = 'V'; Serial: Integer = -1 );
  end;

implementation

uses dmCommingData;

{$R *.DFM}
//======================================================================================================================
{ TFilmEditFR }
//======================================================================================================================
procedure TFilmEditFR.CheckRun( var AFrame: TFilmEditFR; AOwner: TComponent; PAPost: TAfterPostKey; ID: Integer;
                                                                                 FName, Group: String; Serial: Integer );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then AFrame := TFilmEditFR.CreateComming( AOwner, PAPost );
  with AFrame do begin
    RequeryParameters( taData, [ ID ]);
    frHigh.RequeryLookup( dsHigh );
    frGenre.RequeryLookup( dsGenre );
    if taData.RecordCount = 0 then begin
      taData.Insert;
      if FName <> '*' then taDataName.Value := FName;
      taDataGroup.Value := Group;
      if Serial > 0 then taDataHeading.Value := Serial;
    end;
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmEditFR.btRegClick(Sender: TObject);
begin
  if not (taData.State in [ dsInsert, dsEdit ]) then taData.Edit;
  with frArticle.edField      do Text := dmComming.FormatTitle( Text );
  with frName.edField         do Text := dmComming.FormatTitle( Text );
  with frTranslat.edField     do Text := dmComming.FormatTitle( Text );
  with frYearCountry.edField2 do Text := dmComming.FormatTitle( Text );
end;
//======================================================================================================================
procedure TFilmEditFR.Paste( Text: String );
  var buff: TStrings;
begin
  buff := TStringList.Create;
  buff.Text := Text;
  if not (taData.State in [ dsInsert, dsEdit ]) then taData.Edit;
  if (buff.Count > 0) and (buff[0] <> '') then taDataArticle.Value      := dmComming.FormatTitle( buff[0] );
  if (buff.Count > 1) and (buff[1] <> '') then taDataName.Value         := dmComming.FormatTitle( buff[1] );
  if (buff.Count > 2) and (buff[2] <> '') then taDataNameTranslat.Value := dmComming.FormatTitle( buff[2] );
  if (buff.Count > 3) and (buff[3] <> '') then taDataYear.Value         := StrToIntDef( Trim( buff[3] ), 0);
  if (buff.Count > 4) and (buff[4] <> '') then taDataCountry.Value      := dmComming.FormatTitle( buff[4] );
  buff.Free
end;
//======================================================================================================================
procedure TFilmEditFR.btPastClick(Sender: TObject);
begin
  Paste( Clipboard.AsText );
end;
//======================================================================================================================
procedure TFilmEditFR.btSearchClick( Sender: TObject );
begin
  FSearch.CheckRun( FSearch, Owner, Paste, taDataName.Value );
end;
//======================================================================================================================
end.
