{=======================================================================================================================

   "Videoteq".

    , , .

========================================================================================================================

  :

  12.09.2024 [*]     .
  17.10.2012 [*]     .
  11.10.2012 [*]   .
  28.02.2012 [+]  .
  18.01.2011 [*]   .
  14.01.2011 [-]     .
  29.05.2008 [*]     .
  16.05.2008 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frFilmFind.pas,v 1.9 2014/09/14 03:08:45 tsk Exp $
=======================================================================================================================}
unit frFilmFind;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ActnList,
      DB, ADODB, Grids, DBGridEh, StdCtrls, ExtCtrls,
      // BASE:
      BASEfrRoot, BASEfrChoiceGrid,
      // Comming:
      CommingDBGridEh, CommingButton, CommingFlat, CommingADO, CommingString,
      // Videoteq
      frFilmEdit;

type
  TFilmFindFR = class(TBASEChoiceDBGridFR)
    edFind: TcoEdit;
    taChoiceID: TIntegerField;
    taChoiceDisplay: TStringField;
    btTrans: TcoButton;
    procedure edFindChange(Sender: TObject);
    procedure btTransClick(Sender: TObject);
    procedure acInsertExecute(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
  private   { Private declarations }
    FFilm: TFilmEditFR;
    procedure RefreshFilm( Key: Variant );
  public    { Public declarations }
    procedure CheckRun( var AFrame: TFilmFindFR; AOwner: TComponent; PAChoice: TChoiceKey; Film: String );
  end;

implementation

uses dmCommingData;

{$R *.dfm}
//======================================================================================================================
{ TFilmFindFR }
//======================================================================================================================
procedure TFilmFindFR.CheckRun( var AFrame: TFilmFindFR; AOwner: TComponent; PAChoice: TChoiceKey; Film: String);
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then begin
    AFrame := TFilmFindFR.Create( AOwner );
    AFrame.OnChoiceKey  := PAChoice;
  end;
  with AFrame do begin
    FieldKey := taChoiceID;
    Film := StringReplace( Film, '.', ' ', [rfReplaceAll]);
    Film := StringReplace( Film, 'temp', ' ', [rfReplaceAll]);
    Film := StringReplace( Film, '0000', ' ', [rfReplaceAll]);
    Film := DeleteChars( Film, '[]_-()' );
    Film := Trim( Film );
    edFind.Text := Film;
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TFilmFindFR.edFindChange( Sender: TObject );
begin
  RequeryParameters( taChoice, [ trim ( edFind.Text )]);
end;
//======================================================================================================================
procedure TFilmFindFR.btTransClick(Sender: TObject);
begin
  edFind.Text := TransLatinRus( edFind.Text );
end;
//======================================================================================================================
procedure TFilmFindFR.RefreshFilm(Key: Variant);
begin
  RequeryParameters( taChoice, [ trim ( edFind.Text )]);
end;
//======================================================================================================================
procedure TFilmFindFR.acInsertExecute(Sender: TObject);
begin
  FFilm.CheckRun( FFilm, Owner, RefreshFilm, INSERT_DATA, edFind.Text );
end;
//======================================================================================================================
procedure TFilmFindFR.acEditExecute(Sender: TObject);
begin
  FFilm.CheckRun( FFilm, Owner, RefreshFilm, taChoiceID.Value );
end;
//======================================================================================================================
end.
