/*=====================================================================================================================

   "Videoteq".

    .

=======================================================================================================================

  :

  12.09.2014 [*] ListFindFilm:    3  (  ).
             [*] ListFindFilm:  FilmFile.
  23.10.2012 [*] ListFilmAttribute:   ( ).
  18.01.2011 [*] ListFindFilm:  ViewFilmDisplay.
             [+] ViewFilmDisplay:      .
  15.01.2011 [*] ViewUnitDisplay:  .
  14.01.2011 [-] ExecFilmFileInsert.
  13.01.2011 [*] ListFilmUnit:  ViewMediumDisplay.
             [+] ViewMediumDisplay:    .
  28.06.2008 [*] ListFilmAttribute:    .
  30.05.2008 [+] ExecFilmFileInsert:   .
  29.05.2008 [*] FindFilm:     .
  16.05.2008 [+] FindFilm:  .
  08.08.2007 [*] ListFilm:   .
  08.08.2007 [*] ListFilm:  .
  27.07.2007 [*] XLMFilmUnit:  audio.
  24.06.2007 [*] ViewUnitDisplay:  .
  21.06.2007 [*] ListFilmUnit:  ViewUnitDisplay.
             [+] ViewUnitDisplay:    .
  27.03.2007 [*] XLMFilmAttribute:  .
  15.01.2007 [*] ListFilmAttribute: , , ,   .
  12.01.2007 [+] ListFilmUnit: .
  27.12.2006 [+] XLMFilmUnit:    .
  26.12.2006 [+] XLMFilmAttribute:   .
             [+] XLMFilm:    .
  13.12.2006 [*] ListFilmAttribute:   .
  04.12.2006 [*] ListFilm:    .
  10.10.2006 [+] ListFilmAttribute:  .
  26.04.2006 [*] ListFilm:      .
  16.04.2006 [-]  .
  12.04.2006 [*] ListFilmGroup:   .
  05.04.2006 [*]       DisplayRange.
  23.09.2005 [+] ListFilm:   .
  25.07.2005 [-] ListFilm:   ""  "".
  13.04.2005 [*] ListFilmUnit:   .
  22.03.2005 [*]    .
  15.03.2005 [*] ListFilmUnit:  .
  14.03.2005 [*] ListFilmUnit:     .
  09.03.2005 [+] ListFilmUnit:  ,     .
             [+] ListFilmGroup:  .
  04.03.2005 [*] ListFilm:   .
             [*] ListFilm:     .
  29.01.2005 [+] ListFilm:  .
             [+]  .
  17.12.2004 [!]  .

=======================================================================================================================
  Copyright 20042014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scFilm.sql,v 1.42 2014/09/12 05:27:21 tsk Exp $
=====================================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropView      'ViewFilmDisplay'
EXECUTE CheckDropView      'ViewUnitDisplay'
EXECUTE CheckDropView      'ViewMediumDisplay'
EXECUTE CheckDropProcedure 'ListFilm'
EXECUTE CheckDropProcedure 'ListFilmAttribute'
EXECUTE CheckDropProcedure 'ListFilmGroup'
EXECUTE CheckDropProcedure 'ListFilmUnit'
EXECUTE CheckDropProcedure 'XLMFilm'
EXECUTE CheckDropProcedure 'XLMFilmAttribute'
EXECUTE CheckDropProcedure 'XLMFilmUnit'
EXECUTE CheckDropProcedure 'ListFindFilm'
--EXECUTE CheckDropProcedure 'ExecFilmFileInsert'
--
GO
--=====================================================================================================================
CREATE VIEW ViewFilmDisplay
AS
--
  WITH Tree( ID, Heading, Display, lev ) AS 
  ( SELECT ID, Heading, CAST(Display AS VARCHAR(1000)), 0 FROM Film WHERE (Heading IS NULL) 
    UNION ALL
	  SELECT Film.ID, Film.Heading, CAST( Film.Display + '  '+ Tree.Display AS VARCHAR(1000)), lev + 1 
	    FROM Film INNER JOIN Tree ON Tree.ID = Film.Heading
    )
  SELECT Tree.ID, Tree.Display, Film.DisplayRange 
    FROM Tree 
      INNER JOIN Film ON Film.ID = Tree.ID 
--
GO
--=====================================================================================================================
CREATE VIEW ViewUnitDisplay
AS
--
  SELECT Unit.ID, Unit.Film, 
         ISNULL(VideoCodec.Name, '(v-codec?)') 
           + ISNULL(' ' + CAST(Unit.BitrateVideo AS VARCHAR) + 'kb/s', '') 
           + ISNULL(', ' + Unit.Resolution, '') 
           + ISNULL('; ' + AudioCodec.Name + ISNULL(' ' + CAST(Unit.BitrateAudio AS VARCHAR) + 'kb/s', ''), '') 
           + ISNULL('; ' + Unit.Playtime, '') 
           + ISNULL('; ' + CAST(Unit.Size / (1024 * 1024) AS VARCHAR) + 'MiB', '')
             + CASE WHEN DistinctMark IS NULL THEN ' ?' ELSE ' #' END 
           + ISNULL('; ' + Unit.Note, '') AS Display,
         Unit.[Order]
    FROM Unit 
      LEFT OUTER JOIN Codec AS VideoCodec ON Unit.CodecVideo = VideoCodec.ID 
      LEFT OUTER JOIN Codec AS AudioCodec ON Unit.CodecAudio = AudioCodec.ID
--
GO
--=====================================================================================================================
CREATE VIEW ViewMediumDisplay
AS
--
  SELECT Medium.ID,
         Medium.Number + ' [' + MediumKind.Name + ']  ' + Storage.Display AS Display
    FROM Medium 
      INNER JOIN Storage ON Medium.Place = Storage.ID 
      INNER JOIN MediumKind ON Medium.Kind = MediumKind.ID
    WHERE (Storage.Serial IS NULL) AND (Storage.Computer IS NULL)
  --
  UNION
  --
  SELECT Medium.ID, 
         Storage.Name + ':' + Medium.Number + ' [RHHD]'
    FROM Medium 
      INNER JOIN Storage ON Medium.Place = Storage.ID
    WHERE (NOT (Storage.Serial IS NULL))
  --
  UNION
  --
  SELECT Medium.ID, 
         '(' + Storage.Computer + ')' + Medium.Number + ' [HHD]'
    FROM Medium 
      INNER JOIN Storage ON Medium.Place = Storage.ID
    WHERE (NOT (Storage.Computer IS NULL))
--
GO
--=====================================================================================================================
CREATE PROCEDURE ListFilm @GR CHAR(1) = 'V', @HI INT = NULL
AS
  SELECT ID,
         DisplayRange,
         Display,
         Cover, 
         DisplayNote AS Note, 
         Icon,
         CAST(ISNULL(Serias,0) AS BIT) AS Serias,
         ID AS Heading
    FROM Film
    WHERE ([Group] = @GR) AND (Heading IS NULL)-- AND ([Year] IS NULL )
  --  
  UNION ALL
  --
  SELECT Film.ID, 
--         High.DisplayRange + 
         Film.DisplayRange, 
         ' ' + Film.Display,
         Film.Cover, 
         Film.DisplayNote, 
         Film.Icon,
         CAST(ISNULL(Film.Serias,0) AS BIT) AS Serias,
         Film.Heading
    FROM Film 
--      INNER JOIN Film AS High ON Film.Heading = High.ID
    WHERE (Film.[Group] = @GR) 
      AND ((Film.Heading = @HI) OR ((Film.ID = @HI) AND (NOT Heading IS NULL)))
  --
  ORDER BY 2
--
GO
--=====================================================================================================================
CREATE PROCEDURE ListFilmGroup
AS
  SELECT Kind,
         Kind + ' | ' + Name AS Name 
    FROM FilmKind 
    ORDER BY [Order]
--
GO
--=====================================================================================================================
CREATE PROCEDURE ListFilmAttribute @FL INT
AS
  SELECT FilmAttribute.ID,
         FilmAttributeValue.[Group],
         FilmAttributeGroup.Name 
           + ': ' + FilmAttributeValue.ValueFull 
           + ISNULL( '  ' + FilmAttribute.Addition,'') AS FilmAttribute,
         FilmAttributeValue.ID AS ValueID
    FROM FilmAttribute
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
      INNER JOIN FilmAttributeGroup ON FilmAttributeValue.[Group] = FilmAttributeGroup.ID
  WHERE (FilmAttribute.Film = @FL)
  ORDER BY FilmAttributeGroup.Range, FilmAttribute.Range DESC
--
GO
--=====================================================================================================================
CREATE PROCEDURE ListFilmUnit @FL INT
AS
  --SELECT MediumUnit.ID,
  --       Unit.ID AS UnitID,
  --       ViewUnitDisplay.Display
  --         + ISNULL(' | ' + Medium.Number + ' [' + MediumKind.Name + ']  ' 
  --            + Place.Display, '') AS UnitName
  --  FROM Unit
  --    INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
  --    LEFT OUTER JOIN MediumUnit ON Unit.ID = MediumUnit.Unit
  --    LEFT OUTER JOIN MediumKind
  --    INNER JOIN Place 
  --      INNER JOIN Medium ON Place.ID = Medium.Place 
  --                        ON MediumKind.ID = Medium.Kind 
  --                        ON MediumUnit.Medium = Medium.ID
  SELECT MediumUnit.ID, Unit.ID AS UnitID, 
         ViewUnitDisplay.Display + ISNULL(' | ' + ViewMediumDisplay.Display, '') AS UnitName
    FROM ViewMediumDisplay 
      INNER JOIN MediumUnit ON ViewMediumDisplay.ID = MediumUnit.Medium 
      RIGHT OUTER JOIN Unit 
        INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID ON MediumUnit.Unit = Unit.ID
    WHERE (Unit.Film = @FL)
    ORDER BY Unit.[Order]
--
GO
--=====================================================================================================================
CREATE PROCEDURE XLMFilm @FL INT
AS
  SELECT [Group], Article, Name, NameTranslat, [Year], Country, Addition, Cover, Note, [Range]
    FROM Film
    WHERE (ID = @FL)
--
GO
--=====================================================================================================================
CREATE PROCEDURE XLMFilmAttribute @FL INT
AS
  SELECT FilmAttributeGroup.Name  AS AttributeGroup,
         FilmAttributeValue.Value AS AttributeValue,
         FilmAttribute.Addition   AS AttributeAddition
    FROM FilmAttribute
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID 
      INNER JOIN FilmAttributeGroup ON FilmAttributeValue.[Group] = FilmAttributeGroup.ID
    WHERE (FilmAttribute.Film = @FL)
--
GO
--=====================================================================================================================
CREATE PROCEDURE XLMFilmUnit @FL INT
AS
  SELECT ISNULL(CV.Name, '()') AS CodecVideo, 
         Unit.BitrateVideo, Unit.Resolution, 
         CA.Name AS CodecAudio, 
         Unit.BitrateAudio,
         Unit.Playtime, 
         Unit.Size, Unit.Note
    FROM Unit
      LEFT JOIN Codec CV ON Unit.CodecVideo = CV.ID
      LEFT JOIN Codec CA ON Unit.CodecAudio = CA.ID
    WHERE (Unit.Film = @FL)
--
GO
--=====================================================================================================================
CREATE PROCEDURE ListFindFilm @NM VARCHAR(500)
AS
  DECLARE @P1 VARCHAR(100), @P2 VARCHAR(100), @P3 VARCHAR(100), @S INT
  SET @P1 = ''
  SET @P2 = ''
  SET @P3 = ''
  SET @S = CHARINDEX( ' ', @NM )
  IF (@S > 0) BEGIN
    SET @P1 = '%' + SUBSTRING( @NM, 1, @S - 1 ) + '%'
    SET @NM = SUBSTRING( @NM, @S + 1, 500 )
    SET @S = CHARINDEX( ' ', @NM )
  END ELSE SET @P1 = '%' + @NM + '%'
  IF (@S > 0) BEGIN
    SET @P2 = '%' + SUBSTRING( @NM, 1, @S - 1 ) + '%'
    SET @NM = SUBSTRING( @NM, @S + 1, 500 )
    SET @S = CHARINDEX( ' ', @NM )
  END ELSE SET @P2 = '%' + @NM + '%'
  IF (@S > 0) BEGIN
    SET @P3 = '%' + SUBSTRING( @NM, 1, @S - 1 ) + '%'
    SET @NM = SUBSTRING( @NM, @S + 1, 500 )
    SET @S = CHARINDEX( ' ', @NM )
  END ELSE SET @P3 = '%' + @NM + '%'
  SELECT ID, Display, DisplayRange
    FROM  ViewFilmDisplay
    WHERE ((Display LIKE @P1) AND (Display LIKE @P2) AND (Display LIKE @P3))
    ORDER BY DisplayRange
-- 
GO
--=====================================================================================================================
--CREATE PROCEDURE ExecFilmFileInsert @FL INT, @NM VARCHAR(500)
--AS
--  IF NOT EXISTS ( SELECT * FROM FilmFile WHERE (Film = @FL) AND (FileName = @NM))
--    INSERT FilmFile ( Film, FileName ) VALUES ( @FL, @NM )
----
--GO
--=====================================================================================================================
-- 
-- SELECT * FROM ViewFilmDisplay
-- SELECT * FROM ViewUnitDisplay
-- SELECT * FROM ViewMediumDisplay
-- EXECUTE ListFilm 'V', 959
-- EXECUTE ListFilmGroup
-- EXECUTE ListFilmAttribute 854
-- EXECUTE ListFilmUnit 487
-- EXECUTE XLMFilm 716
-- EXECUTE XLMFilmAttribute 716
-- EXECUTE XLMFilmUnit 430
 EXECUTE ListFindFilm 'Potter 2005'
