/*=================================================================================================

   "Videoteq".

     .

===================================================================================================

  :

  18.01.2011 [*]   .
  19.04.2009 [*]      .
  29.05.2008 [*]      .
  31.08.2007 [+]    .
  11.08.2007 [+]     .
             [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scFilmSerias.sql,v 1.5 2011/01/18 08:31:41 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure  'FilmSeriasCount'
EXECUTE CheckDropTrigger    'FilmSeriasInsert'
EXECUTE CheckDropTrigger    'FilmSeriasUpdate'
EXECUTE CheckDropProcedure  'FilmTreeRange'
EXECUTE CheckDropTrigger    'FilmTreeUpdate'
--
GO
--=================================================================================================
CREATE PROCEDURE FilmSeriasCount @ID INT
AS
--
UPDATE Film 
  SET Serias = (SELECT COUNT(*) FROM Film H WHERE H.Heading = @ID)
  WHERE (ID = @ID)
--
GO
--=================================================================================================
CREATE TRIGGER FilmSeriasInsert ON [Film] FOR INSERT AS 
BEGIN
  DECLARE @FL INT
  SELECT @FL = Heading FROM Inserted
  IF NOT @FL IS NULL EXECUTE FilmSeriasCount @FL
END
--
GO
--=================================================================================================
CREATE TRIGGER FilmSeriasUpdate ON [Film] FOR UPDATE AS 
BEGIN
  IF UPDATE ( Heading ) BEGIN
    DECLARE @FL INT
    SELECT @FL = Heading FROM Inserted
    IF NOT @FL IS NULL EXECUTE FilmSeriasCount @FL
    SELECT @FL = Heading FROM Deleted
    IF NOT @FL IS NULL EXECUTE FilmSeriasCount @FL
  END
END
--
GO
--=================================================================================================
CREATE PROCEDURE FilmTreeRange @ID INT, @GR CHAR(1)
AS
  DECLARE @HI INT, @RN VARCHAR(1024)
  SELECT @HI = Heading, @RN = ISNULL([Range], [Name]) FROM Film WHERE ID = @ID
  -- 
  IF NOT @HI IS NULL BEGIN
    SELECT @RN = DisplayRange + '|' + @RN FROM Film WHERE ID = @HI
    UPDATE Film SET [RangeTree] = @RN, [Group] = @GR WHERE ID = @ID
  END ELSE BEGIN
    UPDATE Film SET [RangeTree] = NULL, [Group] = @GR WHERE ID = @ID
  END
  -- 
  IF ( SELECT COUNT(*) FROM Film WHERE Heading = @ID ) > 0 BEGIN
    DECLARE SubItem CURSOR LOCAL FOR SELECT ID FROM Film WHERE Heading = @ID
    OPEN SubItem
    FETCH NEXT FROM SubItem INTO @HI
    WHILE @@FETCH_STATUS = 0 BEGIN
      EXECUTE FilmTreeRange @HI, @GR
      FETCH NEXT FROM SubItem INTO @HI
    END
    CLOSE SubItem
    DEALLOCATE SubItem
  END
--
GO
--=================================================================================================
CREATE TRIGGER FilmTreeUpdate ON Film FOR INSERT, UPDATE AS 
BEGIN
  IF UPDATE ([Range]) OR UPDATE ([Heading]) OR UPDATE ([Group])BEGIN
    DECLARE @FL INT, @GR CHAR(1) 
    SELECT @FL = ID, @GR = [Group] FROM Inserted
    EXECUTE FilmTreeRange @FL, @GR
  END
END
--
GO
--=================================================================================================
-- 
-- EXECUTE FilmSeriasCount 942
-- EXECUTE FilmTreeRange 987
