{=======================================================================================================================

   "Videoteq".

     -.  .

========================================================================================================================

  :

  08.10.2012 [*] SetFileName:  B   .
  06.10.2012 [*]   .
  05.10.2012 [+] SetFileName:  .
  17.01.2011 [*] NewNETFile:     .
             [*] NewHDDFile:     .
  14.01.2011 [+]  .
  05.01.2011 [+]     
  15.09.2008 [+] taUnit:   .
  27.05.2008 [+]   .
  16.05.2008 [+]    .
  15.05.2008 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dmScan.pas,v 1.12 2012/10/22 07:08:33 tsk Exp $
=======================================================================================================================}
unit dmScan;

interface

uses  SysUtils, Classes, DB, ADODB, StrUtils{, Dialogs},
      // Comming:
      CommingFile, CommingADO, CommingSystem, CommingString;

type
  TVideoFile = record
    FileNameFull  : String;
    FilePath      : String;
    DriveSerial   : String;
    FileName      : String;
    ComputerName  : String;
    VolumeName    : String;
    RemovableDisk : Boolean;
    DistinctMark  : String;
    Size          : Int64;
    FileID        : Integer;
    ComputerID    : Integer;
    PathID        : Integer;
    FilmID        : Integer;
    UnitID        : Integer;
    PlaceID       : Integer;
    MediumID      : Integer;
  end;

  TScanDM = class(TDataModule)
    taFindHard: TADODataSet;
    taFindHardID: TIntegerField;
    taComputer: TADODataSet;
    taComputerID: TSmallintField;
    taDir: TADODataSet;
    taDirID: TIntegerField;
    taFilm: TADODataSet;
    taFindLaser: TADODataSet;
    taFindLaserID: TIntegerField;
    taMedium: TADODataSet;
    taMediumID: TIntegerField;
    taMediumPlace: TSmallintField;
    taUnit: TADODataSet;
    taUnitID: TIntegerField;
    taFindRHHD: TADODataSet;
    taFindRHHDID: TIntegerField;
    taFindMarkHHD: TADODataSet;
    taFindMarkHHDID: TIntegerField;
    taFilmFilm: TIntegerField;
    taFindMarkRHHD: TADODataSet;
    taFindMarkRHHDID: TIntegerField;
    taFile: TADODataSet;
    taFileFileName: TStringField;
  private   { Private declarations }
  public    { Public declarations }
    Video: TVideoFile;
    procedure   NewHDDFile( FName: String; Removable: Boolean = False );
    procedure   NewCDFile( FName: String );
    procedure   NewNETFile( FName: String; Removable: Boolean = False );
    procedure   GetComputer;
    procedure   GetDir;
    procedure   GetFilm;
    procedure   GetUnit;
    procedure   GetLaser;
    procedure   SetFileName;
  end;

var ScanDM: TScanDM;

implementation

uses dmCommingData;

{$R *.dfm}
//======================================================================================================================
{ TScanDM }
//======================================================================================================================
procedure TScanDM.NewHDDFile( FName: String; Removable: Boolean );
begin
  with Video do begin
    FileNameFull    := FName;
    FileName        := ExtractFileName( FName );
    Size            := TakeFileSize( FName );
    DistinctMark    := dmComming.DistinctFile( FName );
    RemovableDisk   := Removable;
    if Removable then begin
      VolumeName    := GetVolumeName( FName[1] );
      FilePath      := Copy( ExtractFileDirectory( FName ), 1, MaxInt);
      DriveSerial   := GetVolumeSerialNumber( FName[1] );
      ComputerName  := 'R' + DriveSerial;
      RequeryParameters( taFindMarkRHHD, [ DriveSerial, FilePath, DistinctMark ]);
      if taFindMarkRHHD.RecordCount > 0 then begin
        FileID := taFindMarkRHHDID.Value;
        taFindMarkRHHD.Close;
      end else begin
        RequeryParameters( taFindRHHD, [ FileName, DriveSerial, FilePath, IntToStr( Size )]);
        if taFindRHHD.RecordCount > 0 then FileID := taFindRHHDID.Value else FileID := -1;
        taFindRHHD.Close;
      end;
    end else begin
      FilePath      := GetVolumeName( FName[1] ) + ':' + Copy( ExtractFileDirectory( FName ), 1, MaxInt);
      ComputerName  := GetCompName();
      RequeryParameters( taFindMarkHHD, [ FilePath, DistinctMark ]);
      if taFindMarkHHD.RecordCount > 0 then begin
        FileID := taFindMarkHHDID.Value;
        taFindMarkHHD.Close;
      end else begin
        RequeryParameters( taFindHard, [ FileName, FilePath, IntToStr( Size )]);
        if taFindHard.RecordCount > 0 then FileID := taFindHardID.Value else FileID := -1;
        taFindHard.Close;
      end;
    end;
    ComputerID      := -1;
    PathID          := -1;
    FilmID          := -1;
    UnitID          := -1;
  end;
end;
//======================================================================================================================
procedure TScanDM.NewCDFile(FName: String);
begin
  with Video do begin
    FileNameFull  := FName;
    DriveSerial   := GetVolumeSerialNumber( FName[1] );
    FileName      := ExtractFileName( FName );
    Size          := TakeFileSize( FName );
    DistinctMark  := dmComming.DistinctFile( FName );
    RequeryParameters( taFindLaser, [ FileName, DriveSerial, IntToStr( Size )]);
    if taFindLaser.RecordCount > 0 then FileID := taFindLaserID.Value else FileID := -1;
    taFindLaser.Close;
    PlaceID       := -1;
    MediumID      := -1;
    FilmID        := -1;
    UnitID        := -1;
  end;
end;
//======================================================================================================================
procedure TScanDM.NewNETFile( FName: String; Removable: Boolean );
  var p: Integer;
begin
  with Video do begin
    FileNameFull  := FName;
      FName := CutLeftString( FName, 2 );
      p     := Pos( '\', FName );
    ComputerName  := LeftStr( FName, p - 1 );
      FName := CutLeftString( FName, p );
      p     := Pos( '\', FName );
    VolumeName    := LeftStr( FName, p - 1 );
      FName := CutLeftString( FName, p );
    DriveSerial   := GetVolumeSerialNumber( '\\' + ComputerName + '\' + VolumeName + '\' );
    FilePath      := VolumeName + ':' + Copy( ExtractFileDirectory( FName ), 1, MaxInt);
    FileName      := ExtractFileName( FName );
    Size          := TakeFileSize( FileNameFull );
    DistinctMark  := dmComming.DistinctFile( FileNameFull );
    RequeryParameters( taFindMarkHHD, [ FilePath, DistinctMark ]);
    if taFindMarkHHD.RecordCount > 0 then begin
      FileID := taFindMarkHHDID.Value;
      taFindMarkHHD.Close;
    end else begin
      RequeryParameters( taFindHard, [ FileName, FilePath, IntToStr( Size )]);
      if taFindHard.RecordCount > 0 then FileID := taFindHardID.Value else FileID := -1;
      taFindHard.Close;
    end;
    ComputerID    := -1;
    PathID        := -1;
    FilmID        := -1;
    UnitID        := -1;
  end;
end;
//======================================================================================================================
procedure TScanDM.GetComputer;
begin
  RequeryParameters( taComputer, [ Video.ComputerName ]);
  if taComputer.RecordCount > 0
    then Video.ComputerID := taComputerID.Value
    else Video.ComputerID := -1;
  taComputer.Close;
end;
//======================================================================================================================
procedure TScanDM.GetDir;
begin
  RequeryParameters( taDir, [ Video.FilePath, Video.ComputerID ]);
  if taDir.RecordCount > 0
    then Video.PathID := taDirID.Value
    else Video.PathID := -1;
  taDir.Close;
end;
//======================================================================================================================
procedure TScanDM.GetFilm;
begin
  RequeryParameters( taFilm, [ Video.DistinctMark, ExtractFileNameNoExt( Video.FileName ) ]);
  if taFilm.RecordCount > 0
    then Video.FilmID := taFilmFilm.Value
    else Video.FilmID := -1;
  taFilm.Close;
end;
//======================================================================================================================
procedure TScanDM.GetUnit;
begin
  if Video.FilmID > 0 then begin
    RequeryParameters( taUnit, [ Video.FilmID, IntToStr( Video.Size ), Video.DistinctMark ]);
    if taUnit.RecordCount > 0
      then Video.UnitID := taUnitID.Value
      else Video.UnitID := -1;
    taUnit.Close;
  end;
end;
//======================================================================================================================
procedure TScanDM.GetLaser;
begin
  RequeryParameters( taMedium, [ Video.DriveSerial ]);
  if taMedium.RecordCount > 0 then begin
    Video.PlaceID   := taMediumPlace.Value;
    Video.MediumID  := taMediumID.Value;
  end else begin
    Video.PlaceID   := -1;
    Video.MediumID  := -1;
  end;
  taMedium.Close;
end;
//======================================================================================================================
procedure TScanDM.SetFileName;
  var NewName: String;
begin
  RequeryParameters( taFile, [ Video.FileID, Video.FilmID, Video.UnitID ]);
  NewName := ExtractFilePath( Video.FileNameFull ) + NormalFileName( taFileFileName.Value );
  taFile.Close;
  if Pos( #9, NewName ) > 0 then NewName := Video.FileNameFull + 'TAB.avi';
  if not FileExists( NewName ) then RenameFile( Video.FileNameFull, NewName );
end;
//======================================================================================================================
end.
