{=======================================================================================================================

   "Videoteq".

     -.

========================================================================================================================

  :

  06.10.2013 [+]          .
  07.10.2012 [*]      .
  06.10.2012 [+]   .
  05.10.2012 [+]       .
  26.09.2012 [+]  (skip)  .
  14.01.2011 [+]  .
  05.01.2011 [+]  .
  07.10.2009 [+]   .
  12.02.2009 [+]      (    ).
  28.05.2008 [+]         .
  15.05.2008 [+]  -  .
  14.05.2008 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmScan.pas,v 1.12 2013/10/07 07:25:32 tsk Exp $
=======================================================================================================================}
unit fmScan;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls,
      ExtCtrls, StdCtrls, ActnList, TB2Item, TB2Dock, TB2Toolbar, PropStorageEh, PropFilerEh,
      // BASE:
      BASEfmRoot,
      // Comming:
      CommingOther, CommingProgressBar, CommingFlat, CommingShellFoldersBrowse, CommingFile,
      CommingLog,
      // Videoteq:
      dmCommingData, dmScan, frScanHardEdit, frScanLaserEdit;

type

  TScanFM = class(TBASERootFM)
    lbFiles: TcoListBox;
    bfExport: TcoShellFolderBrowse;
    pbExport: TcoProgressBar;
    tmExport: TTimer;
    imDo: TTBItem;
    TBSeparatorItem4: TTBSeparatorItem;
    imRemovable: TTBItem;
    imFiles: TTBSubmenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure tmExportTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure imFilesClick(Sender: TObject);
    procedure imFilesListClick(Sender: TObject);
    procedure imDoClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure psMainBeforeSaveProps(Sender: TObject);
    procedure psMainAfterLoadProps(Sender: TObject);
  private   { Private declarations }
    FContinuation:  Boolean;
    ScanHDDEdit:    TScanHardEditFR;
    ScanLaserEdit:  TScanLaserEditFR;
    procedure   SetContinuation( Value: Boolean);
    procedure   FillFileList( Path: String );
    procedure   ExportBegin;
    procedure   ContinueDef;
    procedure   ChacngeCaption( S: String = '?' );
    property    Continuation: Boolean read FContinuation write SetContinuation;
  public    { Public declarations }
    procedure   StopExport;
    procedure   AfterSave( Key: Variant );
  end;

  procedure ScanRun;

var ScanFM: TScanFM;

implementation

{$R *.DFM}
//======================================================================================================================
procedure ScanRun;
begin
  if ScanFM = nil then Application.CreateForm(TScanFM, ScanFM);
  ScanFM.Show;
end;
//======================================================================================================================
{ TScanFM }
//======================================================================================================================
procedure TScanFM.FormCreate(Sender: TObject);
begin
  inherited;
  ScanDM := TScanDM.Create( Self );
  DisableItemSelfRun( dmComming.acScan );
  ChacngeCaption( '*' );
end;
//======================================================================================================================
procedure TScanFM.FormDestroy( Sender: TObject );
begin
  inherited;
  ScanFM := nil;
end;
//======================================================================================================================
procedure TScanFM.FormResize(Sender: TObject);
begin
  Height := Height - ( ( lbFiles.Height - ( lbFiles.BevelWidth * 2 )) mod lbFiles.ItemHeight );
end;
//======================================================================================================================
procedure TScanFM.ChacngeCaption( S: String );
begin
  Caption := Format( '[ %s ] ',[ S ]);
end;
//======================================================================================================================
procedure TScanFM.SetContinuation( Value: Boolean );
begin
  if FContinuation <> Value then begin
    Value := ( lbFiles.Items.Count > 0 ) and Value;
    FContinuation     := Value;
    imFiles.Enabled   := not Value;
    tmExport.Enabled  := Value;
    if Value then begin
      imDo.ImageIndex       := 33;
      imDo.Caption          := '';
      if lbFiles.ItemIndex < 0 then lbFiles.ItemIndex := 0;
      pbExport.Max          := lbFiles.Items.Count;
      pbExport.Position     := lbFiles.ItemIndex;
      pbExport.Visible      := True;
    end else begin
      imDo.ImageIndex       := 32;
      imDo.Caption          := '';
      pbExport.Visible      := False;
      Caption               := '';
    end;
  end;
end;
//======================================================================================================================
procedure TScanFM.imFilesClick( Sender: TObject );
  const LList: Integer = 20;
  var iPath: TTBItem;
      i, d: Integer;
      min, path: String;
      new: Boolean;
  function GetClick( dt: TDateTime ): String;
  begin
    Result := FormatDateTime('yyyymmddhhnnsszzz', dt );
  end;
begin
  if bfExport.Execute then begin
    // :
    while imFiles.Count > LList do begin
      d := 0; min := GetClick( Now );
      for i := 0 to imFiles.Count - 1
        do if Copy( imFiles[i].Name, 3, 17 ) <= min then begin
          d   := i;
          min := Copy( imFiles[i].Name, 3, 17 );
        end;
      imFiles.Delete( d ); //   .
    end;
    path := bfExport.Directory;
    d := 0; new := True;
    while d < imFiles.Count do
      if ( imFiles[d].Caption = path ) then begin
        imFiles[d].Name := 'im' + GetClick( Now );
        imFiles[d].Checked := True;
        d := imFiles.Count;
        new := False;
      end else Inc( d );
    if new then begin
      iPath         := TTBItem.Create( imFiles );
      iPath.Name    := 'im' + GetClick( Now );
      iPath.Caption := path;
      iPath.OnClick := imFilesListClick;
      iPath.Checked := True;
      imFiles.Add( iPath );
    end;
    FillFileList( path );
  end
end;
//======================================================================================================================
procedure TScanFM.imFilesListClick( Sender: TObject );
begin
  bfExport.Directory := TTBItem(Sender).Caption;
  FillFileList( TTBItem(Sender).Caption );
end;
//======================================================================================================================
procedure TScanFM.psMainBeforeSaveProps(Sender: TObject);
  var i: Integer;
begin
  for i := 0 to imFiles.Count - 1
    do pbExport.Hint := pbExport.Hint + imFiles[i].Name + '' + imFiles[i].Caption + '|';
end;
//======================================================================================================================
procedure TScanFM.psMainAfterLoadProps(Sender: TObject);
  var iPath: TTBItem;
      p: Integer;
      l, s: String;
begin
//  inherited;
  s := pbExport.Hint;
  while Length( s ) > 0 do begin
    p := Pos( '|', s );
    l := Copy( s, 1, p - 1 );
    s := Copy( s, p + 1, Length( s ));
    p := Pos( '', l );
    if p > 1 then begin
      iPath := TTBItem.Create( imFiles );
      iPath.Name    := Copy( l, 1, p - 1 );
      iPath.Caption := Copy( l, p + 1, Length( l ));
      iPath.OnClick := imFilesListClick;
      imFiles.Add( iPath );
    end;
  end;
  pbExport.Hint := '';
end;
//======================================================================================================================
procedure TScanFM.FillFileList( Path: String );
  var FileList: TStringList;
      i: Integer;
begin
  for i := 0 to imFiles.Count - 1
    do imFiles.Items[i].Checked := ( imFiles.Items[i].Caption = Path );
  ChacngeCaption( 'load' );
  FileList := TStringList.Create;
  FileList.Clear;
  ChacngeCaption;
  Screen.Cursor := crHourGlass;
  RecurseDir( Path, 'avi', FileList, 'skip' );
  RecurseDir( Path, 'mp4', FileList, 'skip' );
  RecurseDir( Path, 'mpeg', FileList, 'skip' );
  RecurseDir( Path, 'mpg', FileList, 'skip' );
  RecurseDir( Path, 'mkv', FileList, 'skip' );
  RecurseDir( Path, 'wmv', FileList, 'skip' );
  FileList.Sort;
  lbFiles.Items.Assign( FileList );
  imDo.Enabled := ( lbFiles.Items.Count > 0 );
  ChacngeCaption( '*' );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TScanFM.tmExportTimer(Sender: TObject);
begin
  tmExport.Enabled := False;
  ExportBegin;
end;
//======================================================================================================================
//   .
procedure TScanFM.ExportBegin;
  var sFile: String;
begin
  sFile := lbFiles.Items[ lbFiles.ItemIndex ];
  if not FileExists( sFile )
    then lbFiles.Items[ lbFiles.ItemIndex ] := lbFiles.Items[ lbFiles.ItemIndex ] + '    !';
  if ( Copy ( sFile, 1, 2 ) = '\\' ) then begin
    ScanDM.NewNETFile( sFile );
    if ScanDM.Video.FileID > 0 then ContinueDef
    else ScanHDDEdit.CheckRun( ScanHDDEdit, self, AfterSave, StopExport );
  end else case GetDiskKind( sFile[1] ) of
    DRIVE_FIXED : begin
                    ScanDM.NewHDDFile( sFile, imRemovable.Checked );
                    if ScanDM.Video.FileID > 0 then ContinueDef
                    else ScanHDDEdit.CheckRun( ScanHDDEdit, self, AfterSave, StopExport );
                  end;
    DRIVE_CDROM: begin
                    ScanDM.NewCDFile( sFile );
                    if ScanDM.Video.FileID > 0 then ContinueDef
                    else ScanLaserEdit.CheckRun( ScanLaserEdit, self, AfterSave, StopExport );
                  end;
  else ContinueDef;
  end;
end;
//======================================================================================================================
procedure TScanFM.AfterSave(Key: Variant);
begin
  ScanDM.SetFileName;
  ContinueDef;
end;
//======================================================================================================================
procedure TScanFM.ContinueDef;
begin
  Application.ProcessMessages;
  ScanDM.SetFileName;
  Continuation := Continuation and not ( lbFiles.ItemIndex = ( lbFiles.Items.Count - 1 ));
  if Continuation then begin
    lbFiles.ItemIndex := lbFiles.ItemIndex + 1;
    pbExport.StepOne;
    tmExport.Enabled  := True;
    ChacngeCaption( IntToStr( Round( pbExport.Position * 100 / pbExport.Max )) + '%' );
  end else ChacngeCaption( '*' );
end;
//======================================================================================================================
procedure TScanFM.imDoClick( Sender: TObject );
begin
  Continuation := not Continuation;
end;
//======================================================================================================================
procedure TScanFM.StopExport;
begin
  Continuation := False;
end;
//======================================================================================================================
end.
