{=======================================================================================================================

   "Videoteq".

     -,  .  .

========================================================================================================================

  :

  10.10.2012 [*]   .
  21.02.2012 [+]   ,    .
  14.01.2011 [+]  .
  11.01.2011 [+]  .
  08.01.2010 [*]       .
  25.09.2008 [+]   .
  17.09.2008 [+]      .
  15.09.2008 [+]   .
  16.05.2008 [+]    .
  15.05.2008 [+]  .
  17.12.2004 [!]  .

========================================================================================================================
  Copyright 20042012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: frScanHardEdit.pas,v 1.11 2012/10/22 07:08:34 tsk Exp $
=======================================================================================================================}
unit frScanHardEdit;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, ADODB,
      StdCtrls, ExtCtrls,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo,
      // Comming:
      CommingFile, CommingButton, CommingADO, CommingString,
      // Videoteq:
      frStorageComputerEdit, frStorageRemovableEdit, frMediumEdit, frFilmFind, frUnitEdit;

type
  TScanHardEditFR = class(TBASEEditFR)
    frName: TBASEDBEditSF;
    taDataID: TAutoIncField;
    taDataMedium: TIntegerField;
    taDataUnit: TIntegerField;
    taDataFileName: TStringField;
    taDataOrder: TIntegerField;
    frComputer: TBASEDBLookupComboSF;
    taComputer: TADODataSet;
    dsComputer: TDataSource;
    frDir: TBASEDBLookupComboSF;
    taDir: TADODataSet;
    dsDir: TDataSource;
    frFilm: TBASEDBLookupComboSF;
    taFilm: TADODataSet;
    dsFilm: TDataSource;
    frUnit: TBASEDBLookupComboSF;
    taUnit: TADODataSet;
    dsUnit: TDataSource;
    procedure frComputercbFieldChange(Sender: TObject);
    procedure frDirbtLabelClick(Sender: TObject);
    procedure frFilmbtLabelClick(Sender: TObject);
    procedure frFilmcbFieldChange(Sender: TObject);
    procedure frUnitbtLabelClick(Sender: TObject);
    procedure frUnitcbFieldChange(Sender: TObject);
    procedure frComputerbtLabelClick(Sender: TObject);
    procedure frDircbFieldChange(Sender: TObject);
    procedure taDataBeforePost(DataSet: TDataSet);
  private   { Private declarations }
    FR      : String;
    FHHD    : TStorageComputerEditFR;
    FRHHD   : TStorageRemovableEditFR;
    FMedium : TMediumEditFR;
    FFilm   : TFilmFindFR;
    FUnit   : TUnitEditFR;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TScanHardEditFR; AOwner: TComponent;
                                                    PAPost: TAfterPostKey; PACancel: TAfterCancel );
    procedure RefreshComp( Key: Variant );
    procedure RefreshDir( Key: Variant );
    procedure RefreshFilm( Key: Variant );
    procedure RefreshUnit( Key: Variant );
  end;

implementation

uses dmScan, dmCommingData;

{$R *.dfm}
//======================================================================================================================
{ TScanHardEditFR }
//======================================================================================================================
procedure TScanHardEditFR.CheckRun(var AFrame: TScanHardEditFR; AOwner: TComponent;
                                                    PAPost: TAfterPostKey; PACancel: TAfterCancel );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then begin
    AFrame := TScanHardEditFR.CreateComming( AOwner, PAPost );
    AFrame.AfterCancel := PACancel;
  end;
  with AFrame do begin
    //   :
    if ScanDM.Video.RemovableDisk then begin
      frComputer.btLabel.Caption := '';
      FR := 'R';
    end else begin
      frComputer.btLabel.Caption := '';
      FR := 'C';
    end;
    RequeryParameters( taComputer, [ FR ]);
    ScanDM.GetComputer;
    frComputer.cbField.KeyValue := ScanDM.Video.ComputerID;
    // :
    ScanDM.GetDir;
    frDircbFieldChange( AFrame );
    // :
    RequeryParameters( taFilm, []);
    ScanDM.GetFilm;
    frFilm.cbField.KeyValue := ScanDM.Video.FilmID;
    // :
    ScanDM.GetUnit;
    // :
    RequeryParameters( taData, [ ScanDM.Video.FileID ]);
    taData.Insert;
    taDataFileName.Value  := ScanDM.Video.FileName;
    taDataUnit.Value      := ScanDM.Video.UnitID;
    taDataMedium.Value    := ScanDM.Video.PathID;
    if (( taDataUnit.Value > 0) and (taDataMedium.Value > 0))
      then btSaveClick( Self )
      else ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TScanHardEditFR.frComputerbtLabelClick(Sender: TObject);
begin
  with ScanDM.Video do
    if RemovableDisk
      then FRHHD.CheckRun( FRHHD, Self.Owner, RefreshComp, INSERT_DATA, DriveSerial, VolumeName )
      else FHHD.CheckRun( FHHD, Self.Owner, RefreshComp, INSERT_DATA, ComputerName );
end;
//======================================================================================================================
procedure TScanHardEditFR.RefreshComp(Key: Variant);
begin
  RequeryParameters( taComputer, [ FR ]);
  ScanDM.Video.ComputerID := Key;
  frComputer.cbField.KeyValue := Key;
end;
//======================================================================================================================
procedure TScanHardEditFR.frComputercbFieldChange(Sender: TObject);
begin
  frComputer.btLabel.NoClick := ( frComputer.cbField.KeyValue <> null );
  RequeryParameters( taDir, [ frComputer.cbField.KeyValue ]);
//  frDir.btLabel.NoClick := ( frDir.cbField.KeyValue <> null );
end;
//======================================================================================================================
procedure TScanHardEditFR.frDircbFieldChange(Sender: TObject);
begin
  frDir.btLabel.NoClick := ( ScanDM.Video.PathID > 0 );
end;
//======================================================================================================================
procedure TScanHardEditFR.frDirbtLabelClick(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self.Owner, RefreshDir, INSERT_DATA, ScanDM.Video.ComputerID, 1, ScanDM.Video.FilePath );
end;
//======================================================================================================================
procedure TScanHardEditFR.RefreshDir( Key: Variant );
begin
  RequeryParameters( taDir, [ frComputer.cbField.KeyValue ]);
  ScanDM.Video.PathID := Key;
  taDataMedium.Value  := Key;
end;
//======================================================================================================================
procedure TScanHardEditFR.frFilmbtLabelClick(Sender: TObject);
  var VFile: String;
begin
  VFile := ExtractFileNameNoExt( ScanDM.Video.FileName );
  FFilm.CheckRun( FFilm, Self.Owner, RefreshFilm, VFile );
end;
//======================================================================================================================
procedure TScanHardEditFR.RefreshFilm( Key: Variant );
begin
  RequeryParameters( taFilm, []);
  ScanDM.Video.FilmID     := Key;
  ScanDM.GetUnit;
  frFilm.cbField.KeyValue := Key;
  frUnit.cbField.KeyValue := ScanDM.Video.UnitID;
end;
//======================================================================================================================
procedure TScanHardEditFR.frFilmcbFieldChange(Sender: TObject);
begin
  RequeryParameters( taUnit, [ frFilm.cbField.KeyValue ]);
end;
//======================================================================================================================
procedure TScanHardEditFR.frUnitbtLabelClick(Sender: TObject);
begin
  FUnit.CheckRun( FUnit, Self.Owner, RefreshUnit, taDataUnit.Value,
                                               frFilm.cbField.KeyValue, ScanDM.Video.FileNameFull );
end;
//======================================================================================================================
procedure TScanHardEditFR.RefreshUnit(Key: Variant);
begin
  RequeryParameters( taUnit, [ frFilm.cbField.KeyValue ]);
  taDataUnit.Value := Key;
end;
//======================================================================================================================
procedure TScanHardEditFR.frUnitcbFieldChange(Sender: TObject);
begin
  if frUnit.cbField.KeyValue > 0
    then frUnit.btLabel.ImageIndex := 10
    else frUnit.btLabel.ImageIndex := 9
end;
//======================================================================================================================
procedure TScanHardEditFR.taDataBeforePost(DataSet: TDataSet);
begin
  inherited;
  ScanDM.Video.UnitID := taDataUnit.Value;
  taDataFileName.Clear;
end;
//======================================================================================================================
end.
