{===================================================================================================

   "Videoteq".

     -,  .  .

====================================================================================================

  :

  27.05.2008 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: frScanLaserEdit.pas,v 1.2 2008/05/28 05:00:19 tsk Exp $
===================================================================================================}
unit frScanLaserEdit;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, ADODB,
      StdCtrls, ExtCtrls,
      // BASE:
      BASEfrEdit, BASEsfDBEdit, BASEsfDBLookupCombo,
      // Comming:
      CommingFile, CommingButton, CommingADO,
      // Videoteq:
      frMediumEdit, frFilmFind, frUnitEdit;

type
  TScanLaserEditFR = class(TBASEEditFR)
    frName: TBASEDBEditSF;
    taDataID: TAutoIncField;
    taDataMedium: TIntegerField;
    taDataUnit: TIntegerField;
    taDataFileName: TStringField;
    taDataOrder: TIntegerField;
    frPlace: TBASEDBLookupComboSF;
    taPlace: TADODataSet;
    dsPlace: TDataSource;
    frMedium: TBASEDBLookupComboSF;
    taMedium: TADODataSet;
    dsMedium: TDataSource;
    frFilm: TBASEDBLookupComboSF;
    taFilm: TADODataSet;
    dsFilm: TDataSource;
    frUnit: TBASEDBLookupComboSF;
    taUnit: TADODataSet;
    dsUnit: TDataSource;
    procedure frComputercbFieldChange(Sender: TObject);
    procedure frDirbtLabelClick(Sender: TObject);
    procedure frFilmbtLabelClick(Sender: TObject);
    procedure frFilmcbFieldChange(Sender: TObject);
    procedure frUnitbtLabelClick(Sender: TObject);
    procedure frUnitcbFieldChange(Sender: TObject);
  private   { Private declarations }
    FMedium : TMediumEditFR;
    FFilm   : TFilmFindFR;
    FUnit   : TUnitEditFR;
  public    { Public declarations }
    procedure CheckRun( var AFrame: TScanLaserEditFR; AOwner: TComponent;
                                                    PAPost: TAfterPostKey; PACancel: TAfterCancel );
    procedure RefreshDir( Key: Variant );
    procedure RefreshFilm( Key: Variant );
    procedure RefreshUnit( Key: Variant );
  end;

implementation

uses dmScan, dmCommingData;

{$R *.dfm}
//==================================================================================================
{ TScanLaserEditFR }
//==================================================================================================
procedure TScanLaserEditFR.CheckRun(var AFrame: TScanLaserEditFR; AOwner: TComponent;
                                                    PAPost: TAfterPostKey; PACancel: TAfterCancel );
begin
  Screen.Cursor := crHourGlass;
  if AFrame = nil then begin
    AFrame := TScanLaserEditFR.CreateComming( AOwner, PAPost );
    AFrame.AfterCancel := PACancel;
  end;
  with AFrame do begin
    // :
    RequeryParameters( taPlace, []);
    // :
    ScanDM.GetLaser;
    frPlace.cbField.KeyValue  := ScanDM.Video.PlaceID;
    // :
    RequeryParameters( taFilm, []);
    ScanDM.GetFilm;
    frFilm.cbField.KeyValue := ScanDM.Video.FilmID;
    // :
    frUnitcbFieldChange(self);
    // :
    RequeryParameters( taData, [ ScanDM.Video.FileID ]);
    taData.Insert;
    taDataFileName.Value  := ScanDM.Video.FileName;
    taDataMedium.Value    := ScanDM.Video.MediumID;
    ShowModal;
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TScanLaserEditFR.frComputercbFieldChange(Sender: TObject);
begin
  RequeryParameters( taMedium, [ frPlace.cbField.KeyValue ]);
  ScanDM.Video.PlaceID := frPlace.KeyValue;
end;
//==================================================================================================
procedure TScanLaserEditFR.frDirbtLabelClick(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self.Owner, RefreshDir, -1, ScanDM.Video.PlaceID, 2, ScanDM.Video.DriveSerial );
end;
//==================================================================================================
procedure TScanLaserEditFR.RefreshDir( Key: Variant );
begin
  RequeryParameters( taMedium, [ frPlace.cbField.KeyValue ]);
  ScanDM.Video.MediumID := Key;
  taDataMedium.Value    := Key;
end;
//==================================================================================================
procedure TScanLaserEditFR.frFilmbtLabelClick(Sender: TObject);
begin
  FFilm.CheckRun( FFilm, Self.Owner, RefreshFilm, ExtractFileNameNoExt( ScanDM.Video.FileName ));
end;
//==================================================================================================
procedure TScanLaserEditFR.RefreshFilm( Key: Variant );
begin
  RequeryParameters( taFilm, []);
  ScanDM.Video.FilmID     := Key;
  frFilm.cbField.KeyValue := Key;
end;
//==================================================================================================
procedure TScanLaserEditFR.frFilmcbFieldChange(Sender: TObject);
begin
  RequeryParameters( taUnit, [ frFilm.cbField.KeyValue ]);
end;
//==================================================================================================
procedure TScanLaserEditFR.frUnitbtLabelClick(Sender: TObject);
begin
  FUnit.CheckRun( FUnit, Self.Owner, RefreshUnit, taDataUnit.Value,
                                               frFilm.cbField.KeyValue, ScanDM.Video.FileNameFull );
end;
//==================================================================================================
procedure TScanLaserEditFR.RefreshUnit(Key: Variant);
begin
  RequeryParameters( taUnit, [ frFilm.cbField.KeyValue ]);
  taDataUnit.Value := Key;
end;
//==================================================================================================
procedure TScanLaserEditFR.frUnitcbFieldChange(Sender: TObject);
begin
  if frUnit.cbField.KeyValue > 0
    then frUnit.btLabel.ImageIndex := 10
    else frUnit.btLabel.ImageIndex := 9
end;
//==================================================================================================
end.
