/*=====================================================================================================================

   "Videoteq".

     -.

=======================================================================================================================

  :

  12.09.2014 [*] FindMarkFilm:  FilmFile.
  06.10.2012 [*] FilmFileName:    .
  05.10.2012 [+] FilmFileName:    .
  15.01.2011 [*]    .
  14.01.2011 [*] FindUnit:  .
             [+] FindMarkFilm:   (    ).
             [+] FindRHHDMarkFile:   (  , ,  ).
             [+] FindHHDMarkFile:   ( ,  ).
  11.01.2011 [+] FindRHHDFile:       .
  15.09.2008 [+] FindUnit:   .
  28.05.2008 [+] LookupMedium:   .
  27.05.2008 [+] FindMedium:   .
             [+] LookupPlace:    .
             [+] FindLaserFile:     .
  17.05.2008 [*] FindFile:     ( 2 147 483 647).
  16.05.2008 [+] LookupUnit:  .
             [+] LookupDir:  .
             [+] FindDir:  .
             [+] LookupComputer:  .
             [+] FindComputer:  .
  15.05.2008 [+] FindFile:  .
             [+]  .
  17.12.2004 [!]  .

=======================================================================================================================
  Copyright 20042014 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: scScan.sql,v 1.10 2014/09/12 05:27:22 tsk Exp $
=====================================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'FindFile'       --    .
EXECUTE CheckDropProcedure 'FindLaserFile'  --     .
EXECUTE CheckDropProcedure 'FindRHHDFile'   --       .

EXECUTE CheckDropProcedure 'FindHHDMarkFile'  --   (),  
EXECUTE CheckDropProcedure 'FindRHHDMarkFile' --   , ,  
EXECUTE CheckDropProcedure 'FindMarkFilm'     --     

EXECUTE CheckDropProcedure 'FindComputer'
EXECUTE CheckDropProcedure 'LookupComputer'
EXECUTE CheckDropProcedure 'FindDir'
EXECUTE CheckDropProcedure 'LookupDir'
EXECUTE CheckDropProcedure 'LookupUnit'
EXECUTE CheckDropProcedure 'LookupPlace'
EXECUTE CheckDropProcedure 'FindMedium'
EXECUTE CheckDropProcedure 'LookupPlaceMedium'
EXECUTE CheckDropProcedure 'FindUnit'

EXECUTE CheckDropProcedure 'FilmFileName'
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindFile @FN VARCHAR(500), @DR VARCHAR(500), @SZ BIGINT
AS
  SELECT MediumUnit.ID
    FROM MediumUnit 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID
    WHERE (MediumUnit.FileName = @FN) AND (Medium.Number = @DR) AND (Unit.Size = @SZ)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindLaserFile @FN VARCHAR(500), @SN VARCHAR(50), @SZ BIGINT
AS
  SELECT MediumUnit.ID
    FROM MediumUnit 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID
    WHERE (MediumUnit.FileName = @FN) AND (Medium.Serial = @SN) AND (Unit.Size = @SZ)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindRHHDFile @FN VARCHAR(500), @SN VARCHAR(50), @DR VARCHAR(500), @SZ BIGINT
AS
  SELECT MediumUnit.ID
    FROM MediumUnit 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
      INNER JOIN Storage ON Medium.Place = Storage.ID
    WHERE (MediumUnit.FileName = @FN) AND (Unit.Size = @SZ) 
                                                AND (Medium.Number = @DR) AND (Storage.Serial = @SN)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindHHDMarkFile @DR VARCHAR(500), @DM CHAR(34)
AS
  SELECT MediumUnit.ID
    FROM MediumUnit 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID
    WHERE (Medium.Number = @DR) AND (Unit.DistinctMark = @DM)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindRHHDMarkFile @SN VARCHAR(50), @DR VARCHAR(500), @DM CHAR(34)
AS
  SELECT MediumUnit.ID
    FROM MediumUnit 
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID 
      INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
      INNER JOIN Storage ON Medium.Place = Storage.ID
    WHERE (Medium.Number = @DR) AND (Storage.Serial = @SN) AND (Unit.DistinctMark = @DM)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindComputer @CM VARCHAR(50)
AS
  SELECT ID
    FROM Place
    WHERE (Computer = @CM ) OR ('R' + Serial = @CM )
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookupComputer @R CHAR(1)
AS
  SELECT ID, Display
    FROM Place
    WHERE (@R = 'C' AND (NOT Computer IS NULL )) OR (@R = 'R' AND (NOT Serial IS NULL ))
    ORDER BY Number
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookupPlace
AS
  SELECT ID, Display
    FROM Place
    WHERE (Computer IS NULL )
    ORDER BY Number
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindDir @DR VARCHAR(500), @CM INT
AS
  SELECT ID
    FROM Medium
    WHERE (Place = @CM) AND (Number = @DR)
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookupDir @CM INT
AS
  SELECT ID, Number AS Name
    FROM Medium
    WHERE (Place = @CM)
    ORDER BY Number
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookupUnit @FL INT
AS
  SELECT ID, Display
    FROM ViewUnitDisplay
    WHERE (Film = @FL)
    ORDER BY [Order]
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindMedium @SN CHAR(9)
AS
  SELECT ID, Place
    FROM Medium
    WHERE (Serial = @SN)
--
GO
--=====================================================================================================================
CREATE PROCEDURE LookupPlaceMedium @PL INT
AS
  SELECT ID, Number + ISNULL( ' [' + Serial + ']', '') AS Name
    FROM Medium
    WHERE (Place = @PL)
    ORDER BY Number
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindUnit @FL INT, @SZ BIGINT, @DM CHAR(34) = '*'
AS
  IF EXISTS (SELECT ID FROM Unit WHERE (DistinctMark = @DM)) 
    SELECT ID FROM Unit WHERE (DistinctMark = @DM)
  ELSE SELECT ID FROM Unit WHERE (Film = @FL) AND (Size = @SZ)
--
GO
--=====================================================================================================================
CREATE PROCEDURE FindMarkFilm @DM CHAR(34), @FN VARCHAR(500) = '*'
AS
  SELECT Film FROM Unit WHERE (DistinctMark = @DM)
--
GO
--=========================================================================================================================================
CREATE PROCEDURE FilmFileName @MU INT, @FL INT, @UN INT
AS
  SELECT TOP(1) ISNULL(CONVERT([varchar], Film.Year, 0) + ' ', '0000 ')
                + ISNULL(Film.Article + ' ', '') 
                  + ISNULL(Film.Name, '?') + ISNULL(' (' + Film.NameTranslat + ')', '')
                + ISNULL(' [' + Film.Addition + ']', '')
                + ISNULL(' [' + Unit.Note + ']', '') 
                + ISNULL('  ' + Film.Country, '') + '.' 
                + ISNULL( UnitExt.FileExt, 'temp.avi') AS FileName
    FROM Film 
      INNER JOIN Unit ON Film.ID = Unit.Film 
      INNER JOIN MediumUnit ON Unit.ID = MediumUnit.Unit
      LEFT JOIN UnitExt ON Unit.Format = UnitExt.UnitFormat
    WHERE (( @MU > 0 ) AND ( MediumUnit.ID = @MU )) OR (( @MU < 0 ) AND ( Film.ID = @FL ) AND ( Unit.ID = @UN ))
    ORDER BY Film.DisplayRange
--
GO
--=========================================================================================================================================
-- 
--EXECUTE FindFile 'Krepkij.oresek-4.2007.DivX.DVDRip-kinozal.tv.avi', 'Video:\@Video\!! \!\ ', '2204608512'
--EXECUTE FindComputer 'TSK-Home'
--EXECUTE LookupComputer
--EXECUTE LookupPlace
--EXECUTE FindDir 'Video:\@Video\!! \!\ ', 4
--EXECUTE LookupDir 4
--EXECUTE LookupUnit 4
--EXECUTE FindLaserFile
--EXECUTE FindMedium 'DD92-1E2D'
--EXECUTE LookupMedium 5
--EXECUTE FindUnit 608, 182452224, '5797E0005797D97803BCE12A83E19981'
EXECUTE FindMarkFilm '5797E0005797D97803BCE12A83E19981'
--EXECUTE FilmFileName 20461, -1, -1
--EXECUTE FilmFileName -1, 2110, 2073
