{===================================================================================================

   "Videoteq".

    , .

====================================================================================================

  :

  28.06.2008 [*]    .
             [*]      .
  14.06.2008 [+]     .
  01.09.2007 [-] .
  24.07.2007 [*]   Windows Vista.
  28.05.2007 [+]      .
  12.01.2007 [+]   .
  16.12.2006 [+]   ,    .
  16.03.2005 [+]  ,  .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042008 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmSearch.pas,v 1.10 2008/09/23 06:15:24 tsk Exp $
===================================================================================================}
unit fmSearch;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, ExtCtrls,
      Dialogs, ActnList, TB2Item, TB2Dock, TB2Toolbar, DB, ADODB, Grids, DBGridEh, StdCtrls,
      ComCtrls, PropStorageEh, DBCtrls, PropFilerEh,
      // BASE:
      BASEfmRoot,
      // Comming:
      CommingDBGridEh, CommingFlat, CommingADO, CommingLookupFlat, CommingParameterTable;

type
  TSearchRoutine = (srFilmName, srAttribName, srAttribCode );

  TSearchFM = class(TBASERootFM)
    grResult: TcoDBGridEh;
    acQuery: TAction;
    edFind: TcoEdit;
    TBItem2: TTBItem;
    taResult: TADODataSet;
    dsResult: TDataSource;
    taResultID: TIntegerField;
    taResultFilm: TStringField;
    taResultGroup: TStringField;
    acFilmGo: TAction;
    TBSeparatorItem4: TTBSeparatorItem;
    TBItem3: TTBItem;
    pnParam: TPanel;
    taAttr: TcoPTable;
    taAttrAttribute: TIntegerField;
    taAttrValue: TIntegerField;
    cbGroup: TcoDBLookupCombo;
    dsAttr: TDataSource;
    cbValue: TcoDBLookupCombo;
    siRoutine: TTBSubmenuItem;
    TBSeparatorItem5: TTBSeparatorItem;
    imFilmName: TTBItem;
    imAttribName: TTBItem;
    imAttribCode: TTBItem;
    TBSeparatorItem6: TTBSeparatorItem;
    imFilmOnly: TTBItem;
    imFilmYear: TTBItem;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure acQueryUpdate(Sender: TObject);
    procedure acQueryExecute(Sender: TObject);
    procedure edFindChange(Sender: TObject);
    procedure grResultDblClick(Sender: TObject);
    procedure acFilmGoUpdate(Sender: TObject);
    procedure imFilmOnlyClick(Sender: TObject);
    procedure imFilmNameClick(Sender: TObject);
    procedure imAttribNameClick(Sender: TObject);
    procedure psMainAfterLoadProps(Sender: TObject);
    procedure imAttribCodeClick(Sender: TObject);
    procedure imFilmYearClick(Sender: TObject);
  private   { Private declarations }
    FNewSearch: Boolean;
    FRoutine:   TSearchRoutine;
    FFilmOnly:  Boolean;
    FByYear: Boolean;
    procedure   SetNewSearch( const Value: Boolean );
    procedure   SetRoutine( const Value: TSearchRoutine );
    procedure   SetFilmOnly( const Value: Boolean );
    procedure   SetByYear(const Value: Boolean);
    procedure   SetStoredProc;
    property    NewSearch: Boolean read FNewSearch write SetNewSearch;
    property    FilmOnly: Boolean read FFilmOnly write SetFilmOnly;
    property    ByYear: Boolean read FByYear write SetByYear;
    property    Routine: TSearchRoutine read FRoutine write SetRoutine;
  public    { Public declarations }
  end;

  procedure SearchRun;
  procedure SearchAttributeRun( ID: Integer );

var SearchFM: TSearchFM;

implementation

uses dmCommingData, dmLookupComboData, dmFindValue;

{$R *.dfm}
//==================================================================================================
{ TSearchFM }
//==================================================================================================
procedure SearchRun;
begin
  if SearchFM = nil then Application.CreateForm( TSearchFM, SearchFM );
  SearchFM.Show;
end;
//==================================================================================================
procedure SearchAttributeRun( ID: Integer );
begin
  SearchRun;
  with SearchFM do begin
    edFind.Text := '';
    taAttr.Edit;
    taAttrAttribute.Value := dmFind.GetAttributeGroup( ID );
    taAttrValue.Value     := ID;
    Routine               := srAttribCode;
    FilmOnly              := True;
    acQueryExecute( SearchFM );
  end;
end;
//==================================================================================================
procedure TSearchFM.FormCreate( Sender: TObject );
begin
  inherited;
  DisableItemSelfRun( dmComming.acSearch );
  taAttr.LoadRecordFromRegistry;
  dmCombo.taAttribute.Open;
  dmCombo.taValue.Open;
  FNewSearch := True;
  FRoutine   := srFilmName;
end;
//==================================================================================================
procedure TSearchFM.psMainAfterLoadProps(Sender: TObject);
begin
  inherited;
  if imFilmName.Checked then imFilmNameClick( Self );
  if imAttribName.Checked then imAttribNameClick( Self );
  if imAttribCode.Checked then imAttribCodeClick( Self );
  FilmOnly := imFilmOnly.Checked;
end;
//==================================================================================================
procedure TSearchFM.FormDestroy(Sender: TObject);
begin
  inherited;
  taAttr.SaveRecordToRegistry;
  SearchFM := nil;
end;
//==================================================================================================
procedure TSearchFM.FormResize(Sender: TObject);
begin
  if grResult.Visible then grResult.HeightBinding( Self );
end;
//==================================================================================================
procedure TSearchFM.SetNewSearch(const Value: Boolean);
begin
  if FNewSearch <> Value then begin
    FNewSearch        := Value;
    grResult.Visible  := ( not NewSearch )
  end;
end;
//==================================================================================================
procedure TSearchFM.SetRoutine( const Value: TSearchRoutine );
begin
  if FRoutine <> Value then begin
    FRoutine := Value;
    NewSearch := True;
    case FRoutine of
      srFilmName:   begin
                      edFind.Visible  := True;
                      edFind.Left     := 0;
                      edFind.Width    := pnParam.ClientWidth;
                      cbGroup.Visible := False;
                      cbValue.Visible := False;
                    end;
      srAttribName: begin
                      cbGroup.Visible := True;
                      edFind.Visible  := True;
                      edFind.Left     := cbGroup.Width + 2;
                      edFind.Width    := pnParam.ClientWidth - edFind.Left;
                      cbValue.Visible := False;
                    end;
      srAttribCode: begin
                      cbGroup.Visible := True;
                      cbValue.Visible := True;
                      cbValue.Left    := cbGroup.Width + 2;
                      cbValue.Width   := pnParam.ClientWidth - cbValue.Left + 1;
                      edFind.Visible  := False;
                    end;
    end;
    SetStoredProc;
  end;
end;
//==================================================================================================
procedure TSearchFM.SetFilmOnly( const Value: Boolean );
begin
  if FFilmOnly <> Value then begin
    FFilmOnly := Value;
    ByYear    := False;
    SetStoredProc;
    NewSearch := True;
    if FFilmOnly then begin
      grResult.Columns[0].Title.Caption := '';
      grResult.RowLines   := 0;
      imFilmYear.Enabled  := True;
    end else begin
      grResult.Columns[0].Title.Caption := ', ,  ';
      grResult.RowLines   := 2;
      imFilmYear.Enabled  := False;
    end;
  end;
end;
//==================================================================================================
procedure TSearchFM.SetByYear(const Value: Boolean);
begin
  if FByYear <> Value then begin
    FByYear := Value and FilmOnly;
    if FByYear then begin
      SetStoredProc;
      NewSearch := True;
      grResult.Columns[0].Title.Caption := ', ';
    end else if FilmOnly then begin
      SetStoredProc;
      NewSearch := True;
      grResult.Columns[0].Title.Caption := '';
    end else begin
      imFilmYear.Checked := False;
    end;
  end;
end;
//==================================================================================================
procedure TSearchFM.edFindChange(Sender: TObject);
begin
  NewSearch := True;
end;
//==================================================================================================
procedure TSearchFM.grResultDblClick(Sender: TObject);
begin
  dmComming.GoToFilm( taResultID.Value );
end;
//==================================================================================================
procedure TSearchFM.SetStoredProc;
begin
  taResult.Close;
  if FFilmOnly and ByYear then
    case FRoutine of
      srFilmName:   taResult.CommandText := 'ListSearchFilmNameFilmOnlyYear';
      srAttribName: taResult.CommandText := 'ListSearchAttribNameFilmOnlyYear';
      srAttribCode: taResult.CommandText := 'ListSearchAttribCodeFilmOnlyYear';
    end
  else if FFilmOnly then
    case FRoutine of
      srFilmName:   taResult.CommandText := 'ListSearchFilmNameFilmOnly';
      srAttribName: taResult.CommandText := 'ListSearchAttribNameFilmOnly';
      srAttribCode: taResult.CommandText := 'ListSearchAttribCodeFilmOnly';
    end
  else
    case FRoutine of
      srFilmName:   taResult.CommandText := 'ListSearchFilmName';
      srAttribName: taResult.CommandText := 'ListSearchAttribName';
      srAttribCode: taResult.CommandText := 'ListSearchAttribCode';
    end;
  taResult.Parameters.Refresh;
end;
//==================================================================================================
{   }
//==================================================================================================
procedure TSearchFM.imFilmNameClick(Sender: TObject);
begin
  imFilmName.Checked := True;
  Routine := srFilmName;
end;
//==================================================================================================
procedure TSearchFM.imAttribNameClick(Sender: TObject);
begin
  imAttribName.Checked := True;
  Routine := srAttribName;
end;
//==================================================================================================
procedure TSearchFM.imAttribCodeClick(Sender: TObject);
begin
  imAttribCode.Checked := True;
  Routine := srAttribCode;
end;
//==================================================================================================
procedure TSearchFM.imFilmOnlyClick(Sender: TObject);
begin
  FilmOnly            := not imFilmOnly.Checked;
  imFilmOnly.Checked  := FilmOnly;
end;
//==================================================================================================
procedure TSearchFM.imFilmYearClick(Sender: TObject);
begin
  ByYear              := NOT imFilmYear.Checked;
  imFilmYear.Checked  := ByYear;
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TSearchFM.acQueryUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := NewSearch;
end;
//==================================================================================================
procedure TSearchFM.acQueryExecute(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  case FRoutine of
    srFilmName:   RequeryParameters( taResult, [ Trim( edFind.Text )]);
    srAttribName: RequeryParameters( taResult, [ cbGroup.KeyValue, Trim( edFind.Text )]);
    srAttribCode: RequeryParameters( taResult, [ cbValue.KeyValue ]);
  end;
  NewSearch := False;
  grResult.SetFocus;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
// 
procedure TSearchFM.acFilmGoUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (not NewSearch) and (taResult.Active) and (taResult.RecordCount > 0);
end;
//==================================================================================================
end.
