/*=================================================================================================

   "Videoteq".

    .

===================================================================================================

  :

  15.09.2008 [+]       .
             [*]         .
  14.07.2008 [*]      .
  23.06.2007 [*] ListSearch:  ViewUnitDisplay.
  28.05.2007 [*] ListSearch:      .
  15.02.2007 [*] ListSearch:    .
  12.01.2007 [+] ListSearch:   .
  16.12.2006 [*] ListSearch:  .
  16.03.2005 [+] ListSearch:       .
             [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scSearch.sql,v 1.11 2008/09/23 06:15:24 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'ListSearch'
EXECUTE CheckDropProcedure 'ListSearchFilmName'
EXECUTE CheckDropProcedure 'ListSearchFilmNameFilmOnly'
EXECUTE CheckDropProcedure 'ListSearchFilmNameFilmOnlyYear'
EXECUTE CheckDropProcedure 'ListSearchAttribName'
EXECUTE CheckDropProcedure 'ListSearchAttribNameFilmOnly'
EXECUTE CheckDropProcedure 'ListSearchAttribNameFilmOnlyYear'
EXECUTE CheckDropProcedure 'ListSearchAttribCode'
EXECUTE CheckDropProcedure 'ListSearchAttribCodeFilmOnly'
EXECUTE CheckDropProcedure 'ListSearchAttribCodeFilmOnlyYear'
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchFilmName @P1 VARCHAR(100)
AS
  SELECT Film.ID, Film.[Group], 
         Film.Display + ISNULL(' [' + ViewUnitDisplay.Display 
                      + ISNULL('  ' + Medium.Number + '/' + MediumKind.Name + '  ' 
                      + Place.Display, '') + ']', '') AS Film
    FROM Film 
      LEFT OUTER JOIN Unit INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
                                                                           ON Film.ID = Unit.Film 
      LEFT OUTER JOIN MediumKind INNER JOIN MediumUnit INNER JOIN Medium 
                                   ON MediumUnit.Medium = Medium.ID ON MediumKind.ID = Medium.Kind 
      INNER JOIN Place ON Medium.Place = Place.ID ON Unit.ID = MediumUnit.Unit
    WHERE (Film.Display LIKE '%' + @P1 + '%')
    ORDER BY Film.Name, Medium.Number  
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchFilmNameFilmOnly @P1 VARCHAR(100)
AS
  SELECT ID, [Group], Display AS Film
    FROM Film
    WHERE (Display LIKE '%' + @P1 + '%')
    ORDER BY Name
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchFilmNameFilmOnlyYear @P1 VARCHAR(100)
AS
  SELECT ID, [Group], DisplayYear AS Film
    FROM Film
    WHERE (Display LIKE '%' + @P1 + '%')
    ORDER BY [Year]
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribName @P1 INT, @P2 VARCHAR(100)
AS
  SELECT Film.ID, 
         Film.[Group],
         Film.Display + ISNULL(' [' + ViewUnitDisplay.Display
                                    + ISNULL('  ' + Medium.Number + '/' + MediumKind.Name + '  ' 
                                    + Place.Display, '') + ']', '') 
                      + ': ' + FilmAttributeValue.Value + ISNULL('  ' + FilmAttribute.Addition, '') AS Film
    FROM ViewUnitDisplay 
      INNER JOIN Unit ON ViewUnitDisplay.ID = Unit.ID 
      FULL OUTER JOIN FilmAttributeValue 
        INNER JOIN FilmAttribute 
        INNER JOIN Film ON FilmAttribute.Film = Film.ID 
                        ON FilmAttributeValue.ID = FilmAttribute.Attribute 
                        ON Unit.Film = Film.ID 
      FULL OUTER JOIN MediumKind 
        INNER JOIN MediumUnit 
        INNER JOIN Medium ON MediumUnit.Medium = Medium.ID 
                          ON MediumKind.ID = Medium.Kind 
      INNER JOIN Place ON Medium.Place = Place.ID 
                       ON Unit.ID = MediumUnit.Unit
    WHERE (FilmAttributeValue.[Group] = @P1) AND (FilmAttributeValue.Value LIKE '%' + @P2 + '%')
    ORDER BY Film.Name, Medium.Number
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribNameFilmOnly @P1 INT, @P2 VARCHAR(100)
AS
  SELECT Film.ID, Film.[Group], 
         Film.Display + ': ' 
                    + FilmAttributeValue.Value + ISNULL('  ' + FilmAttribute.Addition, '') AS Film
    FROM FilmAttributeValue 
      INNER JOIN FilmAttribute INNER JOIN Film 
        ON FilmAttribute.Film = Film.ID 
          ON FilmAttributeValue.ID = FilmAttribute.Attribute
    WHERE (FilmAttributeValue.[Group] = @P1) AND (FilmAttributeValue.Value LIKE '%' + @P2 + '%')
    ORDER BY Film.Name
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribNameFilmOnlyYear @P1 INT, @P2 VARCHAR(100)
AS
  SELECT Film.ID, Film.[Group], 
         Film.DisplayYear + ': ' 
                    + FilmAttributeValue.Value + ISNULL('  ' + FilmAttribute.Addition, '') AS Film
    FROM FilmAttributeValue 
      INNER JOIN FilmAttribute INNER JOIN Film 
        ON FilmAttribute.Film = Film.ID 
          ON FilmAttributeValue.ID = FilmAttribute.Attribute
    WHERE (FilmAttributeValue.[Group] = @P1) AND (FilmAttributeValue.Value LIKE '%' + @P2 + '%')
    ORDER BY Film.[Year]
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribCode @P1 INT
AS
  SELECT Film.ID, 
         Film.[Group],
         Film.Display + ISNULL(' [' + ViewUnitDisplay.Display
                                    + ISNULL('  ' + Medium.Number + '/' + MediumKind.Name + '  ' 
                                    + Place.Display, '') + ']', '') 
            + ISNULL(': ' + FilmAttribute.Addition, '') AS Film
    FROM FilmAttribute 
      INNER JOIN Film ON FilmAttribute.Film = Film.ID 
      LEFT OUTER JOIN ViewUnitDisplay INNER JOIN Unit ON ViewUnitDisplay.ID = Unit.ID 
                                                        ON Film.ID = Unit.Film 
      LEFT OUTER JOIN MediumKind INNER JOIN MediumUnit INNER JOIN Medium 
                          ON MediumUnit.Medium = Medium.ID ON MediumKind.ID = Medium.Kind 
      INNER JOIN Place ON Medium.Place = Place.ID ON Unit.ID = MediumUnit.Unit
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
    WHERE (FilmAttribute.Attribute = @P1)
    ORDER BY Film.Name, Medium.Number  
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribCodeFilmOnly @P1 INT
AS
  SELECT Film.ID, Film.[Group], 
         Film.Display 
            + ISNULL(': ' + FilmAttribute.Addition, '') AS Film
    FROM FilmAttribute 
      INNER JOIN Film ON FilmAttribute.Film = Film.ID 
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
    WHERE (FilmAttribute.Attribute = @P1)
    ORDER BY Film.Name
--
GO
--=================================================================================================
CREATE PROCEDURE ListSearchAttribCodeFilmOnlyYear @P1 INT
AS
  SELECT Film.ID, Film.[Group], 
         Film.DisplayYear 
            + ISNULL(': ' + FilmAttribute.Addition, '') AS Film
    FROM FilmAttribute 
      INNER JOIN Film ON FilmAttribute.Film = Film.ID 
      INNER JOIN FilmAttributeValue ON FilmAttribute.Attribute = FilmAttributeValue.ID
    WHERE (FilmAttribute.Attribute = @P1)
    ORDER BY Film.[Year]
--
GO
--=================================================================================================
-- 
-- EXECUTE ListSearchFilmName 'evil'
-- EXECUTE ListSearchFilmNameFilmOnly 'evil'
-- EXECUTE ListSearchFilmNameFilmOnlyYear 'evil'
-- EXECUTE ListSearchAttribName 3, ''
-- EXECUTE ListSearchAttribNameFilmOnly 3, ''
-- EXECUTE ListSearchAttribNameFilmOnlyYear 3, ''
-- EXECUTE ListSearchAttribCode 1
 EXECUTE ListSearchAttribCodeFilmOnly 3
-- EXECUTE ListSearchAttribCodeFilmOnlyYear 3
