{===================================================================================================

   "Videoteq".

    ,   , , , .

====================================================================================================

  :

  08.01.2011 [+]     ,    .
  07.10.2009 [*]       .
  30.10.2008 [*]     .
  31.05.2008 [*]      .
  13.01.2007 [*]    .
  16.12.2006 [+]   ,    .
  27.05.2006 [+]     .
             [+] : .
             [+]      .
             [*]     .
  05.05.2005 [*] :    .
  22.03.2005 [*] :   .
  16.03.2005 [+] : .
  15.03.2005 [+] : , .
             [+] : , , .
  14.03.2005 [+]  .
  17.12.2004 [!]  .

====================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: fmStorage.pas,v 1.19 2011/01/11 07:07:49 tsk Exp $
===================================================================================================}
unit fmStorage;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
      PropFilerEh, PropStorageEh, ActnList, TB2Item, TB2Dock, TB2Toolbar, ExtCtrls, DB, ADODB,
      Grids, DBGridEh, Menus,
      // BASE:
      BASEfmRoot, BASEsfDBLookupCombo,
      // Comming:
      CommingDBGridEh, CommingADO,
      // Videoteq:
      frStoragePlaceEdit, frStorageComputerEdit, frStorageRemovableEdit, frMediumEdit, qrMediumFilm;

type
  TStorageKind = ( skPlace, skComputer, skRemovableDisk );
  TStorageFM = class(TBASERootFM)
    taPlace: TADODataSet;
    dsPlace: TDataSource;
    grPlace: TcoDBGridEh;
    taPlaceID: TIntegerField;
    taPlaceName: TStringField;
    acPlaceInsert: TAction;
    imInsert: TTBItem;
    acPlaceEdit: TAction;
    imEdit: TTBItem;
    pnMedium: TPanel;
    Splitter1: TSplitter;
    grMedium: TcoDBGridEh;
    taMedium: TADODataSet;
    dsMedium: TDataSource;
    acMediumInsert: TAction;
    acMediumEdit: TAction;
    acMediumDeleteMenu: TAction;
    taMediumID: TIntegerField;
    spMedium: TSplitter;
    TBSeparatorItem4: TTBSeparatorItem;
    imDelete: TTBItem;
    acPlaceDelete: TAction;
    grFilm: TcoDBGridEh;
    taFilm: TADODataSet;
    dsFilm: TDataSource;
    taFilmFilmName: TStringField;
    taFilmFilm: TIntegerField;
    pmPlace: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    acPlaceInsertMenu: TAction;
    acPlaceEditMenu: TAction;
    acPlaceDeleteMenu: TAction;
    N4: TMenuItem;
    acMediumDelete: TAction;
    acMediumEditMenu: TAction;
    acMediumInsertMenu: TAction;
    pmMedium: TPopupMenu;
    N5: TMenuItem;
    Action11: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    taFilmGroup: TStringField;
    acFilmGo: TAction;
    TBSeparatorItem5: TTBSeparatorItem;
    TBItem2: TTBItem;
    TBItem3: TTBItem;
    TBItem4: TTBItem;
    TBItem5: TTBItem;
    acMediumFilm: TAction;
    TBSeparatorItem6: TTBSeparatorItem;
    TBItem6: TTBItem;
    taMediumNumber: TStringField;
    taMediumDisplay: TStringField;
    taPlaceIsHHD: TBooleanField;
    taPlaceIsRemovableDisk: TBooleanField;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure acPlaceInsertUpdate(Sender: TObject);
    procedure acPlaceInsertExecute(Sender: TObject);
    procedure acPlaceEditUpdate(Sender: TObject);
    procedure acPlaceEditExecute(Sender: TObject);
    procedure acPlaceDeleteUpdate(Sender: TObject);
    procedure acPlaceDeleteExecute(Sender: TObject);
    procedure acMediumInsertUpdate(Sender: TObject);
    procedure acMediumInsertExecute(Sender: TObject);
    procedure acMediumEditUpdate(Sender: TObject);
    procedure acMediumEditExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure acMediumDeleteUpdate(Sender: TObject);
    procedure acMediumDeleteExecute(Sender: TObject);
    procedure acFilmGoExecute(Sender: TObject);
    procedure acFilmGoUpdate(Sender: TObject);
    procedure acMediumFilmExecute(Sender: TObject);
    procedure taPlaceAfterScroll(DataSet: TDataSet);
  private
    FStorageKind: TStorageKind;
    procedure SetStorageKind(const Value: TStorageKind);
  private   { Private declarations }
    FIsHard:      Boolean;
    FPlace:       TStoragePlaceEditFR;
    FComputer:    TStorageComputerEditFR;
    FRemovable:   TStorageRemovableEditFR;
    FMedium:      TMediumEditFR;
    FMediumPrint: TMediumFilmQR;
    procedure RefreshPlace( Key: Variant );
    procedure RefreshMedium ( Key: Variant );
    procedure SetIsHard(const Value: Boolean);
    property  IsHard: Boolean read FIsHard write SetIsHard;
    property  StorageKind: TStorageKind read FStorageKind write SetStorageKind;
  public    { Public declarations }
  end;

  procedure   StorageRun( Back: TForm = nil; Data: TField = nil );

  var StorageFM: TStorageFM;

implementation

uses dmCommingData;

{$R *.dfm}
//==================================================================================================
procedure StorageRun( Back: TForm; Data: TField );
begin
  if StorageFM = nil then Application.CreateForm( TStorageFM, StorageFM );
  StorageFM.Show;
end;
//==================================================================================================
{ TStorageFM }
//==================================================================================================
procedure TStorageFM.FormCreate(Sender: TObject);
begin
  inherited;
  DisableItemSelfRun( dmComming.acStorage );
  taPlace.Open;
  taMedium.Open;
  taFilm.Open;
end;
//==================================================================================================
procedure TStorageFM.FormActivate(Sender: TObject);
begin
  inherited;
  RefreshMedium( CURRENT_RECORD );
end;
//==================================================================================================
procedure TStorageFM.FormResize(Sender: TObject);
begin
  inherited;
//  grFilm.HeightBinding( Self );
end;
//==================================================================================================
procedure TStorageFM.FormDestroy(Sender: TObject);
begin
  inherited;
  StorageFM := nil;
end;
//==================================================================================================
procedure TStorageFM.RefreshPlace(Key: Variant);
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taPlaceID.Value;
  taPlace.Requery;
  taPlace.Locate( 'ID', Key, [] );
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TStorageFM.RefreshMedium(Key: Variant);
begin
  Screen.Cursor := crHourGlass;
  if Key = CURRENT_RECORD then Key := taMediumID.Value;
  taMedium.Requery;
  taMedium.Locate( 'ID', Key, [] );
  Screen.Cursor := crDefault;
end;
//==================================================================================================
procedure TStorageFM.taPlaceAfterScroll(DataSet: TDataSet);
begin
  inherited;
  IsHard      := taPlaceIsHHD.Value;
  if taPlaceIsRemovableDisk.Value then StorageKind := skRemovableDisk
  else  if taPlaceIsHHD.Value then StorageKind := skComputer
        else StorageKind := skPlace;
end;
//==================================================================================================
procedure TStorageFM.SetIsHard(const Value: Boolean);
begin
  if FIsHard <> Value then begin
    FIsHard := Value;
    if FIsHard then begin
      grMedium.Align  := alTop;
      spMedium.Align  := alTop;
      spMedium.Top    := grMedium.Top + grMedium.Height;
    end else begin
      grMedium.Align  := alLeft;
      spMedium.Align  := alLeft;
      spMedium.Left   := grMedium.Width;
    end;
  end;
end;
//==================================================================================================
procedure TStorageFM.SetStorageKind( const Value: TStorageKind );
  var KindCapture: String;
begin
  if FStorageKind <> Value then begin
    FStorageKind := Value;
    case FStorageKind of
      skPlace:          KindCapture := '' ;
      skComputer:       KindCapture := '' ;
      skRemovableDisk:  KindCapture := '' ;
    end;
    acPlaceInsert.Caption := KindCapture;
    acPlaceEdit.Caption   := KindCapture;
    acPlaceDelete.Caption := KindCapture;
  end;
end;
//==================================================================================================
{  }
//==================================================================================================
// .
procedure TStorageFM.acPlaceInsertUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grPlace.Focused;
    Enabled := ( taPlace.Active );
  end;
end;
//==================================================================================================
procedure TStorageFM.acPlaceInsertExecute(Sender: TObject);
begin
  case StorageKind of
    skPlace:          FPlace.CheckRun( FPlace, Self, RefreshPlace, INSERT_DATA );
    skComputer:       FComputer.CheckRun( FComputer, Self, RefreshPlace, INSERT_DATA );
    skRemovableDisk:  FRemovable.CheckRun( FRemovable, Self, RefreshPlace, INSERT_DATA );
  end;
end;
//==================================================================================================
// .
procedure TStorageFM.acPlaceEditUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grPlace.Focused;
    Enabled := ( taPlace.Active ) and ( taPlace.RecordCount > 0 );
  end;
end;
//==================================================================================================
procedure TStorageFM.acPlaceEditExecute(Sender: TObject);
begin
  case StorageKind of
    skPlace:          FPlace.CheckRun( FPlace, Self, RefreshPlace, taPlaceID.Value );
    skComputer:       FComputer.CheckRun( FComputer, Self, RefreshPlace, taPlaceID.Value );
    skRemovableDisk:  FRemovable.CheckRun( FRemovable, Self, RefreshPlace, taPlaceID.Value );
  end;
end;
//==================================================================================================
// .
procedure TStorageFM.acPlaceDeleteUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grPlace.Focused;
    Enabled := ( taPlace.Active ) and ( taPlace.RecordCount > 0 )
                                  and ( taMedium.Active ) and ( taMedium.RecordCount = 0 );
  end;
end;
//==================================================================================================
procedure TStorageFM.acPlaceDeleteExecute(Sender: TObject);
begin
  DeleteRecord( 'Place', taPlaceID );
  taPlace.Prior;
  RefreshPlace( CURRENT_RECORD );
end;
//==================================================================================================
{  }
//==================================================================================================
// .
procedure TStorageFM.acMediumInsertUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grMedium.Focused;
    Enabled := ( taPlace.Active ) and ( taPlace.RecordCount > 0 ) and ( taMedium.Active );
  end;
end;
//==================================================================================================
procedure TStorageFM.acMediumInsertExecute(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self, RefreshMedium, INSERT_DATA, taPlaceID.Value  );
end;
//==================================================================================================
// .
procedure TStorageFM.acMediumEditUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grMedium.Focused;
    Enabled := ( taMedium.Active ) and ( taMedium.RecordCount > 0 );
  end;
end;
//==================================================================================================
procedure TStorageFM.acMediumEditExecute(Sender: TObject);
begin
  FMedium.CheckRun( FMedium, Self, RefreshMedium, taMediumID.Value );
end;
//==================================================================================================
// 
procedure TStorageFM.acMediumDeleteUpdate(Sender: TObject);
begin
  with TAction(Sender) do begin
    Visible := grMedium.Focused;
    Enabled := ( taMedium.Active ) and ( taMedium.RecordCount > 0 );
//                                   and ( taFilm.Active ) and ( taFilm.RecordCount = 0 );
  end;
end;
//==================================================================================================
procedure TStorageFM.acMediumDeleteExecute(Sender: TObject);
begin
  DeleteRecord( 'Medium', taMediumID );
  taMedium.Prior;
  RefreshMedium( CURRENT_RECORD );
end;
//==================================================================================================
//  .
procedure TStorageFM.acMediumFilmExecute(Sender: TObject);
begin
  FMediumPrint.CheckRun( FMediumPrint, Self, taPlaceID.Value, taMediumNumber.Value );
end;
//==================================================================================================
{  }
//==================================================================================================
procedure TStorageFM.acFilmGoUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taFilm.Active ) and ( taFilm.RecordCount > 0 );
end;
//==================================================================================================
procedure TStorageFM.acFilmGoExecute(Sender: TObject);
begin
  dmComming.GoToFilm( taFilmFilm.Value );
end;
//==================================================================================================
end.
