/*=================================================================================================

   "Videoteq".

    ,   , , .

===================================================================================================

  :

  08.01.2011 [*] ListPlace:  .
  31.05.2008 [*] ListPlace: .
  28.08.2007 [*] GridPlaceMediumFilm:  .
  23.06.2007 [*] GridPlaceMediumFilm:  ViewUnitDisplay.
  16.12.2006 [*] GridPlaceMediumFilm:  .
  26.04.2006 [-] .
  05.05.2005 [+] GridPlaceMediumFilm:    ListPlaceMediumFilm.
  22.03.2005 [*]    .
  15.03.2005 [*] ListPlace:    "Place".
  14.03.2005 [+] ListPlace:   .
             [+]  .
  17.12.2004 [!]  .

===================================================================================================
  Copyright 20042011 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: scStorage.sql,v 1.16 2011/01/11 07:07:51 tsk Exp $
=================================================================================================*/
USE Videoteq
--
EXECUTE CheckDropProcedure 'ListPlace'
EXECUTE CheckDropProcedure 'ListPlaceMedium'
EXECUTE CheckDropProcedure 'ListPlaceMediumFilm'
EXECUTE CheckDropView      'GridPlaceMediumFilm'
--
GO
--=================================================================================================
CREATE PROCEDURE ListPlace
AS
  SELECT ID, 
         Display AS Name, 
         CAST(ISNULL(LEN(Computer), 0) AS BIT) ^ CAST(ISNULL(LEN(Serial), 0) AS BIT) AS IsHHD, 
         CAST(ISNULL(LEN(Serial), 0) AS BIT) AS IsRemovableDisk
    FROM Storage
    ORDER BY Number
--
GO
--=================================================================================================
CREATE PROCEDURE ListPlaceMedium @PL INT
AS
  SELECT Medium.ID,
         Medium.Number + ' [' + MediumKind.Name + ']' AS Display,
         Medium.Number 
    FROM Medium
      INNER JOIN MediumKind ON Medium.Kind = MediumKind.ID
    WHERE (Medium.Place = @PL)
    ORDER BY Medium.Number
--
GO
--=================================================================================================
CREATE VIEW GridPlaceMediumFilm
AS
  SELECT MediumUnit.Medium AS ID,
         Film.Display + ' [' + ViewUnitDisplay.Display + ']' AS FilmName,
         Film.ID AS Film,
         Film.[Group],
         Film.DisplayRange AS Sort
    FROM MediumUnit
      INNER JOIN Unit ON MediumUnit.Unit = Unit.ID
      INNER JOIN ViewUnitDisplay ON Unit.ID = ViewUnitDisplay.ID 
      INNER JOIN Film ON Unit.Film = Film.ID
--      LEFT OUTER JOIN Codec ON Unit.Codec = Codec.ID
--
GO
--=================================================================================================
-- 
 EXECUTE ListPlace
-- EXECUTE ListPlaceMedium 1
-- EXECUTE ListPlaceMediumFilm 80
--SELECT * FROM GridPlaceMediumFilm WHERE ID = 111 ORDER BY Sort
